var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { Button as VanillaButton } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod, MapsEventListener } from "../HIGAdapter";

var ButtonAdapter = function (_Component) {
  _inherits(ButtonAdapter, _Component);

  function ButtonAdapter() {
    _classCallCheck(this, ButtonAdapter);

    return _possibleConstructorReturn(this, (ButtonAdapter.__proto__ || Object.getPrototypeOf(ButtonAdapter)).apply(this, arguments));
  }

  _createClass(ButtonAdapter, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        HIGAdapter,
        _extends({
          displayName: "Button",
          HIGConstructor: VanillaButton
        }, this.props),
        function (adapterProps) {
          return React.createElement(
            "div",
            null,
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.icon,
              setter: "setIcon"
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.link,
              setter: "setLink"
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.target,
              setter: "setTarget"
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.title,
              setter: "setTitle"
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.type,
              setter: "setType"
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.size,
              setter: "setSize"
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.width,
              setter: "setWidth"
            }, adapterProps)),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.disabled }, adapterProps),
              function (instance, value) {
                return value ? instance.disable() : instance.enable();
              }
            ),
            React.createElement(MapsEventListener, _extends({
              listener: "onBlur",
              handler: _this2.props.onBlur
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onClick",
              handler: _this2.props.onClick
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onFocus",
              handler: _this2.props.onFocus
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onHover",
              handler: _this2.props.onHover
            }, adapterProps))
          );
        }
      );
    }
  }]);

  return ButtonAdapter;
}(Component);

export default ButtonAdapter;


ButtonAdapter.propTypes = {
  /**
   * Prevents user action on the button
   */
  disabled: PropTypes.bool,
  /**
   * Sets the link of a button
   */
  link: PropTypes.string,
  /**
   * Triggers blur when focus is moved away from icon
   */
  onBlur: PropTypes.func,
  /**
   * Triggers when you click the button
   */
  onClick: PropTypes.func,
  /**
   * Triggers when focus is moved to button
   */
  onFocus: PropTypes.func,
  /**
   * Triggers when you hover over the button
   */
  onHover: PropTypes.func,
  /**
   * Specifies size of button
   */
  size: PropTypes.oneOf(VanillaButton.AvailableSizes),
  /**
   * Specifies where to display the linked URL
   */
  target: PropTypes.oneOf(["_self", "_blank", "_parent", "_top"]),
  /**
   * Sets the title of a button
   */
  title: PropTypes.string.isRequired,
  /**
   * Specifies type of button
   */
  type: PropTypes.oneOf(VanillaButton.AvailableTypes),
  /**
   * Specifies width of button (grow or shrink)
   */
  width: PropTypes.oneOf(VanillaButton.AvailableWidths),
  /**
   * An icon name or svg string
   */
  icon: PropTypes.string
};

ButtonAdapter.defaultProps = {
  disabled: false
};
ButtonAdapter.__docgenInfo = {
  "description": "",
  "displayName": "ButtonAdapter",
  "props": {
    "disabled": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Prevents user action on the button",
      "defaultValue": {
        "value": "false",
        "computed": false
      }
    },
    "link": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Sets the link of a button"
    },
    "onBlur": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Triggers blur when focus is moved away from icon"
    },
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Triggers when you click the button"
    },
    "onFocus": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Triggers when focus is moved to button"
    },
    "onHover": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Triggers when you hover over the button"
    },
    "size": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaButton.AvailableSizes"
      },
      "required": false,
      "description": "Specifies size of button"
    },
    "target": {
      "type": {
        "name": "enum",
        "value": [{
          "value": "\"_self\"",
          "computed": false
        }, {
          "value": "\"_blank\"",
          "computed": false
        }, {
          "value": "\"_parent\"",
          "computed": false
        }, {
          "value": "\"_top\"",
          "computed": false
        }]
      },
      "required": false,
      "description": "Specifies where to display the linked URL"
    },
    "title": {
      "type": {
        "name": "string"
      },
      "required": true,
      "description": "Sets the title of a button"
    },
    "type": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaButton.AvailableTypes"
      },
      "required": false,
      "description": "Specifies type of button"
    },
    "width": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaButton.AvailableWidths"
      },
      "required": false,
      "description": "Specifies width of button (grow or shrink)"
    },
    "icon": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "An icon name or svg string"
    }
  }
};