var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";

import { Flyout as VanillaFlyout } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod, MapsEventListener, MountsAnyChild } from "./HIGAdapter";

function FlyoutAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({ displayName: "Flyout", HIGConstructor: VanillaFlyout }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MapsPropToMethod, _extends({
          value: props.anchorPoint,
          setter: "setAnchorPoint"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.maxHeight,
          setter: "setMaxHeight"
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.open }, adapterProps),
          function (instance, value) {
            return value ? instance.open() : instance.close();
          }
        ),
        React.createElement(MapsEventListener, _extends({
          listener: "onClickOutside",
          handler: props.onClickOutside
        }, adapterProps)),
        React.createElement(
          MountsAnyChild,
          _extends({ mounter: "addTarget" }, adapterProps),
          props.children
        ),
        React.createElement(
          MountsAnyChild,
          _extends({ mounter: "addSlot" }, adapterProps),
          props.content
        )
      );
    }
  );
}

FlyoutAdapter.propTypes = {
  anchorPoint: PropTypes.oneOf(VanillaFlyout.AvailableAnchorPoints),
  onClickOutside: PropTypes.func,
  onScroll: PropTypes.func,
  open: PropTypes.bool,
  content: PropTypes.node,
  children: PropTypes.node,
  maxHeight: PropTypes.number
};

FlyoutAdapter.defaultProps = {
  anchorPoint: undefined,
  onClickOutside: function onClickOutside() {},
  onScroll: function onScroll() {},
  open: undefined,
  content: undefined,
  children: undefined
};

export default FlyoutAdapter;
FlyoutAdapter.__docgenInfo = {
  "description": "",
  "displayName": "FlyoutAdapter",
  "props": {
    "anchorPoint": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaFlyout.AvailableAnchorPoints"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onClickOutside": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onScroll": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "open": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "content": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "maxHeight": {
      "type": {
        "name": "number"
      },
      "required": false,
      "description": ""
    }
  }
};