var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { Dropdown as VanillaDropdown } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod, MapsEventListener, MountsHIGChildList } from "../HIGAdapter";

function DropdownAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({}, props, {
      displayName: "Dropdown",
      HIGConstructor: VanillaDropdown
    }),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MapsEventListener, _extends({
          listener: "onBlur",
          handler: props.onBlur
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onClickOutside",
          handler: props.onClickOutside
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onFocus",
          handler: props.onFocus
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onKeypress",
          handler: props.onKeypress
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onTargetClick",
          handler: props.onTargetClick
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.label,
          setter: "setLabel"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.instructions,
          setter: "setInstructions"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.placeholder,
          setter: "setPlaceholder"
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onKeydown",
          handler: props.onKeydown
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.open }, adapterProps),
          function (instance, value) {
            return value ? instance.open() : instance.close();
          }
        ),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.disabled }, adapterProps),
          function (instance, value) {
            return value ? instance.disable() : instance.enable();
          }
        ),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.required }, adapterProps),
          function (instance, value) {
            return value ? instance.required(value) : instance.noLongerRequired();
          }
        ),
        React.createElement(MapsPropToMethod, _extends({
          value: props.selectedOptionLabel,
          setter: "setSelectedOptionLabel"
        }, adapterProps)),
        React.createElement(
          MountsHIGChildList,
          adapterProps,
          props.children
        )
      );
    }
  );
}

DropdownAdapter.propTypes = {
  label: PropTypes.string,
  instructions: PropTypes.string,
  placeholder: PropTypes.string,
  open: PropTypes.bool,
  disabled: PropTypes.bool,
  required: PropTypes.string,
  onBlur: PropTypes.func,
  onClickOutside: PropTypes.func,
  onFocus: PropTypes.func,
  onKeypress: PropTypes.func,
  onTargetClick: PropTypes.func,
  selectedOptionLabel: PropTypes.string,
  children: PropTypes.node
};

DropdownAdapter.defaultProps = {
  label: undefined,
  instructions: undefined,
  placeholder: undefined,
  open: undefined,
  disabled: undefined,
  required: undefined,
  onBlur: undefined,
  onClickOutside: undefined,
  onFocus: undefined,
  onKeypress: undefined,
  onTargetClick: undefined,
  selectedOptionLabel: undefined,
  children: undefined
};

export default DropdownAdapter;
DropdownAdapter.__docgenInfo = {
  "description": "",
  "displayName": "DropdownAdapter",
  "props": {
    "label": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "instructions": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "placeholder": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "open": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "disabled": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "required": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onBlur": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onClickOutside": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onFocus": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onKeypress": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onTargetClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "selectedOptionLabel": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};