var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { Option as VanillaOption } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod, MapsEventListener, MountedByHIGParentList, MountsAnyChild } from "../HIGAdapter";

var OptionAdapter = function (_Component) {
  _inherits(OptionAdapter, _Component);

  function OptionAdapter() {
    _classCallCheck(this, OptionAdapter);

    return _possibleConstructorReturn(this, (OptionAdapter.__proto__ || Object.getPrototypeOf(OptionAdapter)).apply(this, arguments));
  }

  _createClass(OptionAdapter, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        HIGAdapter,
        _extends({}, this.props, {
          displayName: "Option",
          HIGConstructor: VanillaOption
        }),
        function (adapterProps) {
          return React.createElement(
            "div",
            null,
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.value,
              setter: "setValue"
            }, adapterProps)),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.selected }, adapterProps),
              function (instance, value) {
                return value ? instance.select() : instance.deselect();
              }
            ),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.checked }, adapterProps),
              function (instance, value) {
                return value ? instance.check() : instance.uncheck();
              }
            ),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.focused }, adapterProps),
              function (instance, value) {
                return value ? instance.focus() : instance.unfocus();
              }
            ),
            React.createElement(MapsEventListener, _extends({
              listener: "onHover",
              handler: _this2.props.onHover
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onClick",
              handler: _this2.props.onClick
            }, adapterProps)),
            React.createElement(
              MountsAnyChild,
              _extends({ mounter: "setLabel" }, adapterProps),
              _this2.props.label
            ),
            React.createElement(MountedByHIGParentList, _extends({ mounter: "addOption" }, adapterProps))
          );
        }
      );
    }
  }]);

  return OptionAdapter;
}(Component);

export default OptionAdapter;


OptionAdapter.propTypes = {
  /**
   * Called when user moves mouse over the option
   */
  onHover: PropTypes.func,
  /**
   * Called when the user clicks the option
   */
  onClick: PropTypes.func,
  /**
   * Text or HTML displayed for the option
   */
  label: PropTypes.node,
  /**
   * Indicates the option is currently selected
   */
  selected: PropTypes.bool,
  /**
   * Data represented by the option
   */
  value: PropTypes.string
};
OptionAdapter.__docgenInfo = {
  "description": "",
  "displayName": "OptionAdapter",
  "props": {
    "onHover": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user moves mouse over the option"
    },
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when the user clicks the option"
    },
    "label": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Text or HTML displayed for the option"
    },
    "selected": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Indicates the option is currently selected"
    },
    "value": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Data represented by the option"
    }
  }
};