var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { PasswordField as VanillaPasswordField } from "hig-vanilla";
import HIGAdapter, { MapsEventListener, MapsPropToMethod, ControlsProp } from "../HIGAdapter";

function PasswordFieldAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({}, props, {
      displayName: "PasswordField",
      HIGConstructor: VanillaPasswordField
    }),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(ControlsProp, _extends({
          listener: "onInput",
          handler: props.onInput,
          setter: "setValue",
          value: props.value
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onBlur",
          handler: props.onBlur
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onChange",
          handler: props.onChange
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onFocus",
          handler: props.onFocus
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onPasswordRevealButtonClick",
          handler: props.onPasswordRevealButtonClick
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onPasswordHideButtonClick",
          handler: props.onPasswordHideButtonClick
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setInstructions",
          value: props.instructions
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setPlaceholder",
          value: props.placeholder
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setLabel",
          value: props.label
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setName",
          value: props.name
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.disabled }, adapterProps),
          function (instance, value) {
            return value ? instance.disable() : instance.enable();
          }
        ),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.required }, adapterProps),
          function (instance, value) {
            return value ? instance.required(value) : instance.noLongerRequired();
          }
        ),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.revealPassword }, adapterProps),
          function (instance, value) {
            return value ? instance.revealPassword() : instance.hidePassword();
          }
        ),
        React.createElement(
          MapsPropToMethod,
          _extends({
            value: props.showPasswordHideButton
          }, adapterProps),
          function (instance, value) {
            return value ? instance.showPasswordHideButton() : instance.hidePasswordHideButton();
          }
        ),
        React.createElement(
          MapsPropToMethod,
          _extends({
            value: props.showPasswordRevealButton
          }, adapterProps),
          function (instance, value) {
            return value ? instance.showPasswordRevealButton() : instance.hidePasswordRevealButton();
          }
        )
      );
    }
  );
}

PasswordFieldAdapter.propTypes = {
  disabled: PropTypes.bool,
  icon: PropTypes.string,
  instructions: PropTypes.string,
  label: PropTypes.string,
  name: PropTypes.string,
  onBlur: PropTypes.func,
  onChange: PropTypes.func,
  onFocus: PropTypes.func,
  onInput: PropTypes.func,
  onPasswordHideButtonClick: PropTypes.func,
  onPasswordRevealButtonClick: PropTypes.func,
  placeholder: PropTypes.string,
  revealPassword: PropTypes.bool,
  showPasswordHideButton: PropTypes.bool,
  showPasswordRevealButton: PropTypes.bool,
  required: PropTypes.string,
  value: PropTypes.string
};

PasswordFieldAdapter.defaultProps = {
  disabled: undefined,
  icon: undefined,
  instructions: undefined,
  label: undefined,
  name: undefined,
  onBlur: undefined,
  onChange: undefined,
  onFocus: undefined,
  onInput: undefined,
  onPasswordHideButtonClick: undefined,
  onPasswordRevealButtonClick: undefined,
  placeholder: undefined,
  revealPassword: undefined,
  showPasswordHideButton: undefined,
  showPasswordRevealButton: undefined,
  required: undefined,
  value: undefined
};

export default PasswordFieldAdapter;
PasswordFieldAdapter.__docgenInfo = {
  "description": "",
  "displayName": "PasswordFieldAdapter",
  "props": {
    "disabled": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "icon": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "instructions": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "label": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "name": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onBlur": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onChange": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onFocus": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onInput": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onPasswordHideButtonClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onPasswordRevealButtonClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "placeholder": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "revealPassword": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "showPasswordHideButton": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "showPasswordRevealButton": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "required": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "value": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};