var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { RadioButton as VanillaRadioButton } from "hig-vanilla";
import HIGAdapter, { MapsEventListener, MapsPropToMethod, ControlsProp } from "../HIGAdapter";

var RadioButtonAdapter = function (_Component) {
  _inherits(RadioButtonAdapter, _Component);

  function RadioButtonAdapter() {
    _classCallCheck(this, RadioButtonAdapter);

    return _possibleConstructorReturn(this, (RadioButtonAdapter.__proto__ || Object.getPrototypeOf(RadioButtonAdapter)).apply(this, arguments));
  }

  _createClass(RadioButtonAdapter, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        HIGAdapter,
        _extends({}, this.props, {
          displayName: "RadioButton",
          HIGConstructor: VanillaRadioButton
        }),
        function (adapterProps) {
          return React.createElement(
            "div",
            null,
            React.createElement(
              ControlsProp,
              _extends({
                eventTargetPropName: "checked",
                handler: _this2.props.onChange,
                listener: "onChange",
                value: _this2.props.checked,
                defaultValue: _this2.props.defaultChecked
              }, adapterProps),
              function (instance, value) {
                return value ? instance.check() : instance.uncheck();
              }
            ),
            React.createElement(MapsEventListener, _extends({
              listener: "onFocus",
              handler: _this2.props.onFocus
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onHover",
              handler: _this2.props.onFocus
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setLabel",
              value: _this2.props.label
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setName",
              value: _this2.props.name
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setValue",
              value: _this2.props.value
            }, adapterProps)),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.disabled }, adapterProps),
              function (instance, value) {
                return value ? instance.disable() : instance.enable();
              }
            ),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.required }, adapterProps),
              function (instance, value) {
                return value ? instance.required(value) : instance.noLongerRequired();
              }
            )
          );
        }
      );
    }
  }]);

  return RadioButtonAdapter;
}(Component);

export default RadioButtonAdapter;


RadioButtonAdapter.propTypes = {
  /**
   * Checks the checkbox
   */
  checked: PropTypes.bool,
  /**
   * Initially checks the checkbox, but allows user action to change it
   */
  defaultChecked: PropTypes.bool,
  /**
   * Prevents user actions on the checkbox
   */
  disabled: PropTypes.bool,
  /**
   * Text identifying the field
   */
  label: PropTypes.string,
  /**
   * The name of the checkbox as submitted with a form
   */
  name: PropTypes.string,
  /**
   * Called when user moves focus from the field
   */
  onBlur: PropTypes.func,
  /**
   * Called when user changes the value of the field
   */
  onChange: PropTypes.func,
  /**
   * Called when user puts focus on the field
   */
  onFocus: PropTypes.func,
  /**
   * Marks the field as required, text shown to explain requirment
   */
  required: PropTypes.string,
  /**
   * Value submitted with a form if checked
   */
  value: PropTypes.string
};
RadioButtonAdapter.__docgenInfo = {
  "description": "",
  "displayName": "RadioButtonAdapter",
  "props": {
    "checked": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Checks the checkbox"
    },
    "defaultChecked": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Initially checks the checkbox, but allows user action to change it"
    },
    "disabled": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Prevents user actions on the checkbox"
    },
    "label": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Text identifying the field"
    },
    "name": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "The name of the checkbox as submitted with a form"
    },
    "onBlur": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user moves focus from the field"
    },
    "onChange": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user changes the value of the field"
    },
    "onFocus": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user puts focus on the field"
    },
    "required": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Marks the field as required, text shown to explain requirment"
    },
    "value": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Value submitted with a form if checked"
    }
  }
};