var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { Range as VanillaRange } from "hig-vanilla";
import HIGAdapter, { MapsEventListener, MapsPropToMethod, ControlsProp } from "../HIGAdapter";

var RangeAdapter = function (_Component) {
  _inherits(RangeAdapter, _Component);

  function RangeAdapter() {
    _classCallCheck(this, RangeAdapter);

    return _possibleConstructorReturn(this, (RangeAdapter.__proto__ || Object.getPrototypeOf(RangeAdapter)).apply(this, arguments));
  }

  _createClass(RangeAdapter, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        HIGAdapter,
        _extends({}, this.props, {
          displayName: "Range",
          HIGConstructor: VanillaRange
        }),
        function (adapterProps) {
          return React.createElement(
            "div",
            null,
            React.createElement(ControlsProp, _extends({
              handler: _this2.props.onInput,
              listener: "onInput",
              setter: "setValue",
              value: _this2.props.value,
              defaultValue: _this2.props.defaultValue
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onBlur",
              handler: _this2.props.onBlur
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onChange",
              handler: _this2.props.onChange
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onFocus",
              handler: _this2.props.onFocus
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setInstructions",
              value: _this2.props.instructions
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setLabel",
              value: _this2.props.label
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setMin",
              value: _this2.props.min
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setMax",
              value: _this2.props.max
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setStep",
              value: _this2.props.step
            }, adapterProps)),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.disabled }, adapterProps),
              function (instance, value) {
                return value ? instance.disable() : instance.enable();
              }
            ),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.required }, adapterProps),
              function (instance, value) {
                return value ? instance.required(value) : instance.noLongerRequired();
              }
            )
          );
        }
      );
    }
  }]);

  return RangeAdapter;
}(Component);

export default RangeAdapter;


RangeAdapter.propTypes = {
  /**
   * Initial value of the field, user action will override
   */
  defaultValue: PropTypes.string,
  /**
   * Prevents user actions on the field
   */
  disabled: PropTypes.bool,
  /**
   * Instructional text for the field
   */
  instructions: PropTypes.string,
  /**
   * Text describing what the field represents
   */
  label: PropTypes.string,
  /**
   * Name of the field when submitted with a form
   */
  name: PropTypes.string,
  /**
   * Called when user moves focus from the field
   */
  onBlur: PropTypes.func,
  /**
   * Called after user changes the value of the field
   */
  onChange: PropTypes.func,
  /**
   * Called when user puts focus onto the field
   */
  onFocus: PropTypes.func,
  /**
   * Called as user changes the value of the field
   */
  onInput: PropTypes.func,
  /**
   * Text describing why the field is required
   */
  required: PropTypes.string,
  /**
   * Value of the field
   */
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
};
RangeAdapter.__docgenInfo = {
  "description": "",
  "displayName": "RangeAdapter",
  "props": {
    "defaultValue": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Initial value of the field, user action will override"
    },
    "disabled": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Prevents user actions on the field"
    },
    "instructions": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Instructional text for the field"
    },
    "label": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Text describing what the field represents"
    },
    "name": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Name of the field when submitted with a form"
    },
    "onBlur": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user moves focus from the field"
    },
    "onChange": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called after user changes the value of the field"
    },
    "onFocus": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user puts focus onto the field"
    },
    "onInput": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called as user changes the value of the field"
    },
    "required": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Text describing why the field is required"
    },
    "value": {
      "type": {
        "name": "union",
        "value": [{
          "name": "string"
        }, {
          "name": "number"
        }]
      },
      "required": false,
      "description": "Value of the field"
    }
  }
};