var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { TextField as VanillaTextField } from "hig-vanilla";
import HIGAdapter, { MapsEventListener, MapsPropToMethod, ControlsProp } from "../HIGAdapter";

var TextFieldAdapter = function (_Component) {
  _inherits(TextFieldAdapter, _Component);

  function TextFieldAdapter() {
    _classCallCheck(this, TextFieldAdapter);

    return _possibleConstructorReturn(this, (TextFieldAdapter.__proto__ || Object.getPrototypeOf(TextFieldAdapter)).apply(this, arguments));
  }

  _createClass(TextFieldAdapter, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        HIGAdapter,
        _extends({}, this.props, {
          displayName: "TextField",
          HIGConstructor: VanillaTextField
        }),
        function (adapterProps) {
          return React.createElement(
            "div",
            null,
            React.createElement(ControlsProp, _extends({
              handler: _this2.props.onInput,
              listener: "onInput",
              setter: "setValue",
              value: _this2.props.value,
              defaultValue: _this2.props.defaultValue
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onBlur",
              handler: _this2.props.onBlur
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onChange",
              handler: _this2.props.onChange
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onClearButtonClick",
              handler: _this2.props.onClearButtonClick
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onFocus",
              handler: _this2.props.onFocus
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setInstructions",
              value: _this2.props.instructions
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setPlaceholder",
              value: _this2.props.placeholder
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setLabel",
              value: _this2.props.label
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setName",
              value: _this2.props.name
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setIcon",
              value: _this2.props.icon
            }, adapterProps)),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.disabled }, adapterProps),
              function (instance, value) {
                return value ? instance.disable() : instance.enable();
              }
            ),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.required }, adapterProps),
              function (instance, value) {
                return value ? instance.required(value) : instance.noLongerRequired();
              }
            ),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.errors }, adapterProps),
              function (instance, value) {
                return typeof value === "string" ? instance.setErrors(value) : instance.unsetErrors();
              }
            ),
            React.createElement(
              MapsPropToMethod,
              _extends({
                value: _this2.props.hideInstructionsOnErrors
              }, adapterProps),
              function (instance, value) {
                return instance.hideInstructionsOnErrors(value);
              }
            ),
            React.createElement(
              MapsPropToMethod,
              _extends({
                value: _this2.props.showClearButton
              }, adapterProps),
              function (instance, value) {
                return value ? instance.showClearButton() : instance.hideClearButton();
              }
            )
          );
        }
      );
    }
  }]);

  return TextFieldAdapter;
}(Component);

export default TextFieldAdapter;


TextFieldAdapter.propTypes = {
  /**
   * Initial value of the field, user actions will override
   */
  defaultValue: PropTypes.string,
  /**
   * Prevents user actions on the field
   */
  disabled: PropTypes.bool,
  /**
   * Error text for the field. Setting this value applies error styling to the entire component.
   */
  errors: PropTypes.string,
  /**
   * When true, displays passed error text. When false, displays instructions with error styling.
   */
  hideInstructionsOnErrors: PropTypes.bool,
  /**
   * Icon for the field, either the name of an included icon, or an svg string of a custom icon
   */
  icon: PropTypes.string,
  /**
   * Instructional text for the field
   */
  instructions: PropTypes.string,
  /**
   * Text describing what the field represents
   */
  label: PropTypes.string,
  /**
   * Name of the field when submitted with a form
   */
  name: PropTypes.string,
  /**
   * Called when user moves focus from the field
   */
  onBlur: PropTypes.func,
  /**
   * Called after user changes the value of the field
   */
  onChange: PropTypes.func,
  /**
   * Called when user clicks the clear button
   */
  onClearButtonClick: PropTypes.func,
  /**
   * Called when user puts focus onto the field
   */
  onFocus: PropTypes.func,
  /**
   * Called as user changes the value of the field
   */
  onInput: PropTypes.func,
  /**
   * Example of what the user should type into the field
   */
  placeholder: PropTypes.string,
  /**
   * Text describing why the field is required
   */
  required: PropTypes.string,
  /**
   * When true, causes the clear button to appear
   */
  showClearButton: PropTypes.bool,
  /**
   * Value of the field
   */
  value: PropTypes.string
};
TextFieldAdapter.__docgenInfo = {
  "description": "",
  "displayName": "TextFieldAdapter",
  "props": {
    "defaultValue": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Initial value of the field, user actions will override"
    },
    "disabled": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Prevents user actions on the field"
    },
    "errors": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Error text for the field. Setting this value applies error styling to the entire component."
    },
    "hideInstructionsOnErrors": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "When true, displays passed error text. When false, displays instructions with error styling."
    },
    "icon": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Icon for the field, either the name of an included icon, or an svg string of a custom icon"
    },
    "instructions": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Instructional text for the field"
    },
    "label": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Text describing what the field represents"
    },
    "name": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Name of the field when submitted with a form"
    },
    "onBlur": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user moves focus from the field"
    },
    "onChange": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called after user changes the value of the field"
    },
    "onClearButtonClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user clicks the clear button"
    },
    "onFocus": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user puts focus onto the field"
    },
    "onInput": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called as user changes the value of the field"
    },
    "placeholder": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Example of what the user should type into the field"
    },
    "required": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Text describing why the field is required"
    },
    "showClearButton": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "When true, causes the clear button to appear"
    },
    "value": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Value of the field"
    }
  }
};