var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MapsEventListener, MapsPropToMethod, MountedByHIGParent } from "../../HIGAdapter";

function ModuleAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "Collapse",
      HIGConstructor: VanillaGlobalNav._partials.SideNav._partials.SideNavFull._partials.Group._partials.Module._partials.Collapse
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MapsEventListener, _extends({
          listener: "onClick",
          handler: props.onClick
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.minimized }, adapterProps),
          function (instance, value) {
            return value ? instance.minimize() : instance.maximize();
          }
        ),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.hidden }, adapterProps),
          function (instance, value) {
            return value ? instance.hide() : instance.show();
          }
        ),
        React.createElement(MountedByHIGParent, _extends({ mounter: "addCollapse" }, adapterProps))
      );
    }
  );
}

ModuleAdapter.propTypes = {
  onClick: PropTypes.func,
  minimized: PropTypes.bool,
  hidden: PropTypes.bool
};

ModuleAdapter.defaultProps = {
  onClick: undefined,
  minimized: undefined,
  hidden: undefined
};

export default ModuleAdapter;
ModuleAdapter.__docgenInfo = {
  "description": "",
  "displayName": "ModuleAdapter",
  "props": {
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "minimized": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "hidden": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};