var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod, MapsEventListener, MountedByHIGParentList } from "../../HIGAdapter";

function LinkAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "Link",
      HIGConstructor: VanillaGlobalNav._partials.SideNav._partials.SideNavFull._partials.Link
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MapsPropToMethod, _extends({
          value: props.link,
          setter: "setLink"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.target,
          setter: "setTarget"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.title,
          setter: "setTitle"
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          handler: props.onClick,
          listener: "onClick"
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          handler: props.onHover,
          listener: "onHover"
        }, adapterProps)),
        React.createElement(MountedByHIGParentList, _extends({ mounter: "addLink" }, adapterProps))
      );
    }
  );
}

LinkAdapter.propTypes = {
  link: PropTypes.string,
  target: PropTypes.string,
  title: PropTypes.string,
  onClick: PropTypes.func,
  onHover: PropTypes.func
};

export default LinkAdapter;
LinkAdapter.__docgenInfo = {
  "description": "",
  "displayName": "LinkAdapter",
  "props": {
    "link": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": ""
    },
    "target": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": ""
    },
    "title": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": ""
    },
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": ""
    },
    "onHover": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": ""
    }
  }
};