var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod, MapsEventListener, MountedByHIGParent, ControlsProp } from "../../HIGAdapter";

function SearchAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "Search",
      HIGConstructor: VanillaGlobalNav._partials.SideNav._partials.SideNavFull._partials.Search
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MapsPropToMethod, _extends({
          value: props.icon,
          setter: "setIcon"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.placeholder,
          setter: "setPlaceholder"
        }, adapterProps)),
        React.createElement(ControlsProp, _extends({
          listener: "onInput",
          handler: props.onInput,
          value: props.value,
          setter: "setValue"
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.clearIconVisible }, adapterProps),
          function (instance, value) {
            return value ? instance.showClearIcon() : instance.hideClearIcon();
          }
        ),
        React.createElement(MapsEventListener, _extends({
          listener: "onFocusOut",
          handler: props.onBlur
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onFocusIn",
          handler: props.onFocus
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onClearIconClick",
          handler: props.onClearIconClick
        }, adapterProps)),
        React.createElement(MountedByHIGParent, _extends({ mounter: "addSearch" }, adapterProps))
      );
    }
  );
}

SearchAdapter.propTypes = {
  onInput: PropTypes.func,
  clearIconVisible: PropTypes.bool,
  onBlur: PropTypes.func,
  onFocus: PropTypes.func,
  icon: PropTypes.string,
  placeholder: PropTypes.string,
  value: PropTypes.string,
  onClearIconClick: PropTypes.func
};

SearchAdapter.defaultProps = {
  onInput: undefined,
  clearIconVisible: undefined,
  onBlur: undefined,
  onFocus: undefined,
  icon: undefined,
  placeholder: undefined,
  value: undefined,
  onClearIconClick: undefined
};

export default SearchAdapter;
SearchAdapter.__docgenInfo = {
  "description": "",
  "displayName": "SearchAdapter",
  "props": {
    "onInput": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "clearIconVisible": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onBlur": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onFocus": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "icon": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "placeholder": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "value": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onClearIconClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};