var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MapsEventListener, MountedByHIGParent, MountsHIGChild } from "../../HIGAdapter";

export default function SideNavAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "SideNav",
      HIGConstructor: VanillaGlobalNav._partials.SideNav
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParent, _extends({ mounter: "addSideNav" }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onMouseEnter",
          handler: props.onMouseEnter
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onMouseLeave",
          handler: props.onMouseLeave
        }, adapterProps)),
        React.createElement(
          MountsHIGChild,
          adapterProps,
          props.children
        )
      );
    }
  );
}

SideNavAdapter.propTypes = {
  children: PropTypes.node,
  /**
   * Callback for when user first starts hovering over the sidenav
   */
  onMouseEnter: PropTypes.func,
  /**
   * Callback for when user stops hovering over the sidenav
   */
  onMouseLeave: PropTypes.func
};

SideNavAdapter.defaultProps = {
  children: null
};
SideNavAdapter.__docgenInfo = {
  "description": "",
  "displayName": "SideNavAdapter",
  "props": {
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "null",
        "computed": false
      }
    },
    "onMouseEnter": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Callback for when user first starts hovering over the sidenav"
    },
    "onMouseLeave": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Callback for when user stops hovering over the sidenav"
    }
  }
};