var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MapsEventListener, MapsPropToMethod, MountedByHIGParent, MountsHIGChildList } from "../../HIGAdapter";

import GroupAdapter from "./GroupAdapter";

function sortChildren(children) {
  return {
    groups: children.filter(function (child) {
      return child.type === GroupAdapter;
    })
  };
}

export default function SideNavCompactAdapter(props) {
  var _sortChildren = sortChildren(React.Children.toArray(props.children)),
      groups = _sortChildren.groups;

  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "SideNavCompact",
      HIGConstructor: VanillaGlobalNav._partials.SideNav._partials.SideNavCompact
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParent, _extends({ mounter: "addContent" }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({
            value: props.showVariantToggleButton
          }, adapterProps),
          function (instance, value) {
            return value ? instance.showVariantToggleButton() : instance.hideVariantToggleButton();
          }
        ),
        React.createElement(MapsEventListener, _extends({
          listener: "onVariantToggleClick",
          handler: props.onVariantToggleClick
        }, adapterProps)),
        React.createElement(
          MountsHIGChildList,
          adapterProps,
          groups
        )
      );
    }
  );
}

SideNavCompactAdapter.propTypes = {
  /**
   * Calls the provided callback when user clicks on the expand button
   */
  onVariantToggleClick: PropTypes.func,
  /**
   * Show or hide the expand button
   */
  showVariantToggleButton: PropTypes.bool
};

SideNavCompactAdapter.defaultProps = {
  showVariantToggleButton: true
};
SideNavCompactAdapter.__docgenInfo = {
  "description": "",
  "displayName": "SideNavCompactAdapter",
  "props": {
    "onVariantToggleClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Calls the provided callback when user clicks on the expand button"
    },
    "showVariantToggleButton": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Show or hide the expand button",
      "defaultValue": {
        "value": "true",
        "computed": false
      }
    }
  }
};