var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MapsEventListener, MapsPropToMethod, MountedByHIGParentList } from "../../HIGAdapter";

function SubmoduleAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "Submodule",
      HIGConstructor: VanillaGlobalNav._partials.SideNav._partials.SideNavFull._partials.Group._partials.Module._partials.Submodule
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParentList, _extends({ mounter: "addSubmodule" }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onClick",
          handler: props.onClick
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onHover",
          handler: props.onHover
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.show, setter: "show" }, adapterProps),
          function (instance, value) {
            return value ? instance.show() : instance.hide();
          }
        ),
        React.createElement(MapsPropToMethod, _extends({
          value: props.link,
          setter: "setLink"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.title,
          setter: "setTitle"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.target,
          setter: "setTarget"
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.active }, adapterProps),
          function (instance, value) {
            return value ? instance.activate() : instance.deactivate();
          }
        )
      );
    }
  );
}

SubmoduleAdapter.propTypes = {
  active: PropTypes.bool,
  onClick: PropTypes.func,
  onHover: PropTypes.func,
  link: PropTypes.string,
  show: PropTypes.bool,
  title: PropTypes.string,
  target: PropTypes.string
};

SubmoduleAdapter.defaultProps = {
  active: undefined,
  onClick: undefined,
  onHover: undefined,
  link: undefined,
  show: true,
  title: undefined
};

export default SubmoduleAdapter;
SubmoduleAdapter.__docgenInfo = {
  "description": "",
  "displayName": "SubmoduleAdapter",
  "props": {
    "active": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onHover": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "link": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "show": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "true",
        "computed": false
      }
    },
    "title": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "target": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": ""
    }
  }
};