var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MapsEventListener, MapsPropToMethod, MountedByHIGParent, MountsHIGChildList } from "../../HIGAdapter";

function SubNavAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "SubNav",
      HIGConstructor: VanillaGlobalNav._partials.SubNav
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParent, _extends({ mounter: "addSubNav" }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onModuleIndicatorClick",
          handler: props.onModuleIndicatorClick
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.moduleIndicatorName,
          setter: "setModuleIndicatorName"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.moduleIndicatorIcon,
          setter: "setModuleIndicatorIcon"
        }, adapterProps)),
        React.createElement(
          MountsHIGChildList,
          adapterProps,
          props.children
        )
      );
    }
  );
}

SubNavAdapter.propTypes = {
  children: PropTypes.node,
  onModuleIndicatorClick: PropTypes.func,
  moduleIndicatorIcon: PropTypes.string,
  moduleIndicatorName: PropTypes.string
};

SubNavAdapter.defaultProps = {
  children: undefined,
  onModuleIndicatorClick: undefined,
  moduleIndicatorIcon: undefined,
  moduleIndicatorName: undefined
};

export default SubNavAdapter;
SubNavAdapter.__docgenInfo = {
  "description": "",
  "displayName": "SubNavAdapter",
  "props": {
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onModuleIndicatorClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "moduleIndicatorIcon": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "moduleIndicatorName": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};