var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MapsEventListener, MapsPropToMethod, MountedByHIGParentList } from "../../HIGAdapter";

function TabsAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "Tab",
      HIGConstructor: VanillaGlobalNav._partials.SubNav._partials.Tabs._partials.Tab
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParentList, _extends({ mounter: "addTab" }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onClick",
          handler: props.onClick
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setLabel",
          value: props.label
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.active }, adapterProps),
          function (instance, value) {
            return value ? instance.activate() : instance.deactivate();
          }
        )
      );
    }
  );
}

TabsAdapter.propTypes = {
  onClick: PropTypes.func,
  label: PropTypes.string,
  active: PropTypes.bool
};

TabsAdapter.defaultProps = {
  onClick: undefined,
  label: undefined,
  active: undefined
};

export default TabsAdapter;
TabsAdapter.__docgenInfo = {
  "description": "",
  "displayName": "TabsAdapter",
  "props": {
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "label": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "active": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};