var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod, MapsEventListener, MountedByHIGParent, MountsHIGChildList } from "../../HIGAdapter";

function HelpAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "Help",
      HIGConstructor: VanillaGlobalNav._partials.TopNav._partials.Help
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParent, _extends({ mounter: "addHelp" }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          handler: props.onClick,
          listener: "onClick"
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          handler: props.onClickOutside,
          listener: "onClickOutside"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.title,
          setter: "setTitle"
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.open }, adapterProps),
          function (instance, value) {
            return value ? instance.open() : instance.close();
          }
        ),
        React.createElement(
          MountsHIGChildList,
          adapterProps,
          props.children
        )
      );
    }
  );
}

HelpAdapter.propTypes = {
  title: PropTypes.string,
  link: PropTypes.string,
  onClick: PropTypes.func,
  onClickOutside: PropTypes.func,
  open: PropTypes.bool,
  children: PropTypes.node
};

HelpAdapter.defaultProps = {
  title: undefined,
  link: undefined,
  onClick: undefined,
  onClickOutside: undefined,
  open: undefined,
  children: undefined
};

export default HelpAdapter;
HelpAdapter.__docgenInfo = {
  "description": "",
  "displayName": "HelpAdapter",
  "props": {
    "title": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "link": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onClickOutside": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "open": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};