var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { Notification as VanillaNotification } from "hig-vanilla";

import HIGAdapter, { MountedByHIGParent, MapsPropToMethod, MountsAnyChild, MapsEventListener } from "../../HIGAdapter";

var NotificationAdapter = function (_Component) {
  _inherits(NotificationAdapter, _Component);

  function NotificationAdapter() {
    _classCallCheck(this, NotificationAdapter);

    return _possibleConstructorReturn(this, (NotificationAdapter.__proto__ || Object.getPrototypeOf(NotificationAdapter)).apply(this, arguments));
  }

  _createClass(NotificationAdapter, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        HIGAdapter,
        _extends({
          displayName: "NotificationAdapter",
          HIGConstructor: VanillaNotification
        }, this.props),
        function (adapterProps) {
          return React.createElement(
            "div",
            null,
            React.createElement(MountedByHIGParent, _extends({ mounter: "addNotification" }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.timestamp,
              setter: "setCreatedAt"
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onLinkClick",
              handler: _this2.props.onLinkClick
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onDismiss",
              handler: _this2.props.onDismiss
            }, adapterProps)),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.unread }, adapterProps),
              function (instance, value) {
                return value ? instance.markUnread() : instance.markRead();
              }
            ),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.featured }, adapterProps),
              function (instance, value) {
                return value ? instance.setFeatured() : instance.removeFeatured();
              }
            ),
            React.createElement(
              MountsAnyChild,
              _extends({ mounter: "setContent" }, adapterProps),
              _this2.props.children
            )
          );
        }
      );
    }
  }]);

  return NotificationAdapter;
}(Component);

export default NotificationAdapter;


NotificationAdapter.propTypes = {
  /**
   * A callback called when user clicks on a link in the notification
   */
  onLinkClick: PropTypes.func,
  /**
   * A callback called when user dismisses a featured notification
   */
  onDismiss: PropTypes.func,
  /**
   * {Boolean} to show specify whether notificaiton is read
   */
  unread: PropTypes.bool,
  /**
   * Indicates whether this is a featured notification
   */
  featured: PropTypes.bool,
  /**
   * Content for notification
   */
  children: PropTypes.node,
  /**
   * Timestamp for notification
   */
  timestamp: PropTypes.oneOfType([PropTypes.string, PropTypes.instanceOf(Date)]) // ISO date string
};
NotificationAdapter.__docgenInfo = {
  "description": "",
  "displayName": "NotificationAdapter",
  "props": {
    "onLinkClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "A callback called when user clicks on a link in the notification"
    },
    "onDismiss": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "A callback called when user dismisses a featured notification"
    },
    "unread": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "{Boolean} to show specify whether notificaiton is read"
    },
    "featured": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Indicates whether this is a featured notification"
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Content for notification"
    },
    "timestamp": {
      "type": {
        "name": "union",
        "value": [{
          "name": "string"
        }, {
          "name": "instanceOf",
          "value": "Date"
        }]
      },
      "required": false,
      "description": "Timestamp for notification"
    }
  }
};