var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { Notifications as VanillaNotifications } from "hig-vanilla";
import HIGAdapter, { MountsAnyChild, MountedByHIGParent, MapsPropToMethod, MapsEventListener } from "../../HIGAdapter";

function NotificationsAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "Notifications",
      HIGConstructor: VanillaNotifications
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParent, _extends({ mounter: "addNotifications" }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setUnseenCount",
          value: props.unseenCount
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.loading }, adapterProps),
          function (instance, value) {
            return value ? instance.setLoading() : instance.setNotLoading();
          }
        ),
        React.createElement(
          MapsPropToMethod,
          _extends({
            value: props.showNotificationsCount
          }, adapterProps),
          function (instance, value) {
            return value ? instance.showNotificationsCount() : instance.hideNotificationsCount();
          }
        ),
        React.createElement(MapsPropToMethod, _extends({
          value: props.title,
          setter: "setTitle"
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.open }, adapterProps),
          function (instance, value) {
            return value ? instance.open() : instance.close();
          }
        ),
        React.createElement(MapsEventListener, _extends({
          listener: "onClickOutside",
          handler: props.onClickOutside
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onClick",
          handler: props.onClick
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onScroll",
          handler: props.onScroll
        }, adapterProps)),
        React.createElement(
          MountsAnyChild,
          _extends({ mounter: "addNotification" }, adapterProps),
          props.children
        )
      );
    }
  );
}

NotificationsAdapter.propTypes = {
  open: PropTypes.bool,
  loading: PropTypes.bool,
  showUnreadBadge: PropTypes.bool,
  unseenCount: PropTypes.number,
  onClick: PropTypes.func,
  onClickOutside: PropTypes.func,
  onScroll: PropTypes.func
};

NotificationsAdapter.defaultProps = {};

export default NotificationsAdapter;
NotificationsAdapter.__docgenInfo = {
  "description": "",
  "displayName": "NotificationsAdapter",
  "props": {
    "open": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": ""
    },
    "loading": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": ""
    },
    "showUnreadBadge": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": ""
    },
    "unseenCount": {
      "type": {
        "name": "number"
      },
      "required": false,
      "description": ""
    },
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": ""
    },
    "onClickOutside": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": ""
    },
    "onScroll": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": ""
    }
  }
};