var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MapsEventListener, MapsPropToMethod } from "../../HIGAdapter";
import MountedByHIGParentList from "../../HIGAdapter/MountedByHIGParentList";

function OptionAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({}, props, {
      displayName: "Option",
      HIGConstructor: VanillaGlobalNav._partials.TopNav._partials.Help._partials.Option
    }),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParentList, _extends({ mounter: "addOption" }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onClick",
          handler: props.onClick
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setName",
          value: props.name
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setLink",
          value: props.link
        }, adapterProps))
      );
    }
  );
}

OptionAdapter.propTypes = {
  onClick: PropTypes.func,
  name: PropTypes.string,
  link: PropTypes.string
};

OptionAdapter.defaultProps = {
  onClick: undefined,
  name: undefined,
  link: undefined
};

export default OptionAdapter;
OptionAdapter.__docgenInfo = {
  "description": "",
  "displayName": "OptionAdapter",
  "props": {
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "name": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "link": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};