var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MountedByHIGParent, MapsPropToMethod, MapsEventListener } from "../../HIGAdapter";

function ProfileAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({}, props, {
      displayName: "Profile",
      HIGConstructor: VanillaGlobalNav._partials.TopNav._partials.Profile
    }),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParent, _extends({ mounter: "addProfile" }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onSignOutClick",
          handler: props.onSignOutClick
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onProfileSettingsClick",
          handler: props.onProfileSettingsClick
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onProfileImageClick",
          handler: props.onProfileImageClick
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onProfileClickOutside",
          handler: props.onProfileClickOutside
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setImage",
          value: props.image
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setName",
          value: props.name
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setProfileSettingsLabel",
          value: props.profileSettingsLabel
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setProfileSettingsLink",
          value: props.profileSettingsLink
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setSignOutLabel",
          value: props.signOutLabel
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setSignOutLink",
          value: props.signOutLink
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setEmail",
          value: props.email
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.open }, adapterProps),
          function (instance, value) {
            return value ? instance.open() : instance.close();
          }
        )
      );
    }
  );
}

ProfileAdapter.propTypes = {
  email: PropTypes.string,
  image: PropTypes.string,
  name: PropTypes.string,
  profileSettingsLabel: PropTypes.string,
  profileSettingsLink: PropTypes.string,
  signOutLabel: PropTypes.string,
  signOutLink: PropTypes.string,
  open: PropTypes.bool,
  onSignOutClick: PropTypes.func,
  onProfileSettingsClick: PropTypes.func,
  onProfileImageClick: PropTypes.func,
  onProfileClickOutside: PropTypes.func
};

ProfileAdapter.defaultProps = {
  email: undefined,
  image: undefined,
  name: undefined,
  profileSettingsLabel: undefined,
  profileSettingsLink: undefined,
  signOutLabel: undefined,
  signOutLink: undefined,
  open: undefined,
  onSignOutClick: undefined,
  onProfileSettingsClick: undefined,
  onProfileImageClick: undefined,
  onProfileClickOutside: undefined
};

export default ProfileAdapter;
ProfileAdapter.__docgenInfo = {
  "description": "",
  "displayName": "ProfileAdapter",
  "props": {
    "email": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "image": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "name": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "profileSettingsLabel": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "profileSettingsLink": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "signOutLabel": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "signOutLink": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "open": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onSignOutClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onProfileSettingsClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onProfileImageClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onProfileClickOutside": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};