var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MountedByHIGParent, MapsPropToMethod, MapsEventListener, MountsHIGChildList } from "../../HIGAdapter";
import ProjectAdapter from "./ProjectAdapter";
import AccountAdapter from "./AccountAdapter";
import Project from "../../../elements/components/GlobalNav/TopNav/Project";
import Account from "../../../elements/components/GlobalNav/TopNav/Account";

function sortChildren(children) {
  return {
    projects: children.filter(function (child) {
      return [ProjectAdapter, Project].includes(child.type);
    }),
    accounts: children.filter(function (child) {
      return [AccountAdapter, Account].includes(child.type);
    })
  };
}

function ProjectAccountSwitcherAdapter(props) {
  var _sortChildren = sortChildren(React.Children.toArray(props.children)),
      projects = _sortChildren.projects,
      accounts = _sortChildren.accounts;

  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "ProjectAccountSwitcher",
      HIGConstructor: VanillaGlobalNav._partials.TopNav._partials.ProjectAccountSwitcher
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParent, _extends({
          mounter: "addProjectAccountSwitcher"
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onClick",
          handler: props.onClick
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onClickOutside",
          handler: props.onClickOutside
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setProjectTitle",
          value: props.projectTitle
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setAccountTitle",
          value: props.accountTitle
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setActiveImage",
          value: props.activeImage
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setActiveLabel",
          value: props.activeLabel
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setActiveType",
          value: props.activeType
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.open }, adapterProps),
          function (instance, value) {
            return value ? instance.open() : instance.close();
          }
        ),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.showCaret }, adapterProps),
          function (instance, value) {
            return value ? instance.showCaret() : instance.hideCaret();
          }
        ),
        React.createElement(
          MountsHIGChildList,
          adapterProps,
          projects
        ),
        React.createElement(
          MountsHIGChildList,
          adapterProps,
          accounts
        )
      );
    }
  );
}

ProjectAccountSwitcherAdapter.propTypes = {
  children: PropTypes.node,
  onClick: PropTypes.func,
  onClickOutside: PropTypes.func,
  projectTitle: PropTypes.string,
  accountTitle: PropTypes.string,
  activeImage: PropTypes.string,
  activeLabel: PropTypes.string,
  activeType: PropTypes.string,
  open: PropTypes.bool,
  showCaret: PropTypes.bool
};

ProjectAccountSwitcherAdapter.defaultProps = {
  children: undefined,
  projectTitle: undefined,
  accountTitle: undefined,
  activeImage: undefined,
  activeLabel: undefined,
  activeType: undefined
};

export default ProjectAccountSwitcherAdapter;
ProjectAccountSwitcherAdapter.__docgenInfo = {
  "description": "",
  "displayName": "ProjectAccountSwitcherAdapter",
  "props": {
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": ""
    },
    "onClickOutside": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": ""
    },
    "projectTitle": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "accountTitle": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "activeImage": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "activeLabel": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "activeType": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "open": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": ""
    },
    "showCaret": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": ""
    }
  }
};