var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MountedByHIGParentList, MapsPropToMethod, MapsEventListener } from "../../HIGAdapter";

function ProjectAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({}, props, {
      displayName: "Project",
      HIGConstructor: VanillaGlobalNav._partials.TopNav._partials.ProjectAccountSwitcher._partials.Project
    }),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParentList, _extends({ mounter: "addProject" }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onClick",
          handler: props.onClick
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setImage",
          value: props.image
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setLabel",
          value: props.label
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.active }, adapterProps),
          function (instance, value) {
            return value ? instance.activate() : instance.deactivate();
          }
        )
      );
    }
  );
}

ProjectAdapter.propTypes = {
  active: PropTypes.bool,
  label: PropTypes.string,
  image: PropTypes.string,
  onClick: PropTypes.func
};

ProjectAdapter.defaultProps = {
  active: undefined,
  label: undefined,
  image: undefined,
  onClick: undefined
};

export default ProjectAdapter;
ProjectAdapter.__docgenInfo = {
  "description": "",
  "displayName": "ProjectAdapter",
  "props": {
    "active": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "label": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "image": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};