var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MountedByHIGParent, MapsPropToMethod, MapsEventListener, MountsHIGChildList, ControlsProp } from "../../HIGAdapter";

function SearchAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "Search",
      HIGConstructor: VanillaGlobalNav._partials.TopNav._partials.Search
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParent, _extends({ mounter: "addSearch" }, adapterProps)),
        React.createElement(ControlsProp, _extends({
          listener: "onInput",
          handler: props.onInput,
          value: props.value,
          setter: "setValue"
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onFocusIn",
          handler: props.onFocus
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onFocusOut",
          handler: props.onBlur
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onClearIconClick",
          handler: props.onClearIconClick
        }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          listener: "onKeydown",
          handler: props.onKeydown
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          setter: "setPlaceholder",
          value: props.placeholder
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.showClearIcon }, adapterProps),
          function (instance, value) {
            return value ? instance.showClearIcon() : instance.hideClearIcon();
          }
        ),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.showOptions }, adapterProps),
          function (instance, value) {
            return value ? instance.showOptions() : instance.hideOptions();
          }
        ),
        React.createElement(MapsEventListener, _extends({
          listener: "onClickOutside",
          handler: props.onClickOutside
        }, adapterProps)),
        React.createElement(
          MountsHIGChildList,
          adapterProps,
          props.children
        )
      );
    }
  );
}

SearchAdapter.propTypes = {
  placeholder: PropTypes.string,
  clearIconVisible: PropTypes.bool,
  onClearIconClick: PropTypes.func,
  onInput: PropTypes.func,
  onFocus: PropTypes.func,
  onBlur: PropTypes.func,
  showClearIcon: PropTypes.bool,
  showOptions: PropTypes.bool,
  children: PropTypes.node
};

SearchAdapter.defaultProps = {
  query: undefined,
  placeholder: undefined,
  clearIconVisible: undefined,
  onClearIconClick: undefined,
  onInput: undefined,
  onFocus: undefined,
  onBlur: undefined,
  showClearIcon: undefined,
  showOptions: undefined,
  children: undefined
};

export default SearchAdapter;
SearchAdapter.__docgenInfo = {
  "description": "",
  "displayName": "SearchAdapter",
  "props": {
    "placeholder": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "clearIconVisible": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onClearIconClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onInput": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onFocus": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onBlur": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "showClearIcon": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "showOptions": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "query": {
      "defaultValue": {
        "value": "undefined",
        "computed": true
      },
      "required": false
    }
  }
};