var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { GlobalNav as VanillaGlobalNav } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod, MapsEventListener, MountedByHIGParent } from "../../HIGAdapter";

function ShortcutAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "Shortcut",
      HIGConstructor: VanillaGlobalNav._partials.TopNav._partials.Shortcut
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParent, _extends({ mounter: "addShortcut" }, adapterProps)),
        React.createElement(MapsEventListener, _extends({
          handler: props.onClick,
          listener: "onClick"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.icon,
          setter: "setIcon"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.link,
          setter: "setLink"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.title,
          setter: "setTitle"
        }, adapterProps))
      );
    }
  );
}

ShortcutAdapter.propTypes = {
  onClick: PropTypes.func,
  icon: PropTypes.string,
  link: PropTypes.string,
  title: PropTypes.string
};

ShortcutAdapter.defaultProps = {
  onClick: undefined,
  icon: undefined,
  link: undefined,
  title: undefined
};

export default ShortcutAdapter;
ShortcutAdapter.__docgenInfo = {
  "description": "",
  "displayName": "ShortcutAdapter",
  "props": {
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "icon": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "link": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "title": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};