var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { Grid as VanillaGrid } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod, MountedByHIGParentList, MountsAnyChild } from "./HIGAdapter";

var GridItemAdapter = function (_Component) {
  _inherits(GridItemAdapter, _Component);

  function GridItemAdapter() {
    _classCallCheck(this, GridItemAdapter);

    return _possibleConstructorReturn(this, (GridItemAdapter.__proto__ || Object.getPrototypeOf(GridItemAdapter)).apply(this, arguments));
  }

  _createClass(GridItemAdapter, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        HIGAdapter,
        _extends({}, this.props, {
          displayName: "GridItem",
          HIGConstructor: VanillaGrid._partials.GridItem
        }),
        function (adapterProps) {
          return React.createElement(
            "div",
            null,
            React.createElement(MountedByHIGParentList, _extends({ mounter: "addGridItem" }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setFraction",
              value: _this2.props.fraction
            }, adapterProps)),
            _this2.props.children ? React.createElement(
              MountsAnyChild,
              _extends({ mounter: "addSlot" }, adapterProps),
              _this2.props.children
            ) : null
          );
        }
      );
    }
  }]);

  return GridItemAdapter;
}(Component);

export default GridItemAdapter;


GridItemAdapter.propTypes = {
  /**
   * Fraction in english, with 1, 2, 4, 8, 12 as nominators
   * So our possible values are:
   *   'one-whole'
   *   'one-half'
   *   'one-quarter'
   *   'two-quarter'
   *   'three-quarter'
   *   'one-eighth'
   *   'two-eighths'
   *   'three-eighths'
   *   'four-eighths'
   *   'five-eights'
   *   'six-eighths'
   *   'seven-eighths'
   *   'one-twelfth'
   *   'two-twelfths'
   *   'three-twelfths'
   *   'four-twelfths'
   *   'five-twelfths'
   *   'six-twelfths'
   *   'seven-twelfths'
   *   'eight-twelfths'
   *   'nine-twelfths'
   *   'ten-twelfths'
   *   'eleven-twelfths'
   */
  fraction: PropTypes.oneOf(VanillaGrid._partials.GridItem.AvailableFractions).isRequired,
  /**
   * Content for the grid item
   */
  children: PropTypes.node
};
GridItemAdapter.__docgenInfo = {
  "description": "",
  "displayName": "GridItemAdapter",
  "props": {
    "fraction": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaGrid._partials.GridItem.AvailableFractions"
      },
      "required": true,
      "description": "Fraction in english, with 1, 2, 4, 8, 12 as nominators\nSo our possible values are:\n  'one-whole'\n  'one-half'\n  'one-quarter'\n  'two-quarter'\n  'three-quarter'\n  'one-eighth'\n  'two-eighths'\n  'three-eighths'\n  'four-eighths'\n  'five-eights'\n  'six-eighths'\n  'seven-eighths'\n  'one-twelfth'\n  'two-twelfths'\n  'three-twelfths'\n  'four-twelfths'\n  'five-twelfths'\n  'six-twelfths'\n  'seven-twelfths'\n  'eight-twelfths'\n  'nine-twelfths'\n  'ten-twelfths'\n  'eleven-twelfths'"
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Content for the grid item"
    }
  }
};