var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* eslint-disable react/forbid-prop-types */
import { Component } from "react";
import PropTypes from "prop-types";
import HIGPropTypes from "./HIGPropTypes";
import throwIfNoHIGMethod from "./throwIfNoHIGMethod";

var ControlsProp = function (_Component) {
  _inherits(ControlsProp, _Component);

  function ControlsProp(props) {
    _classCallCheck(this, ControlsProp);

    var _this = _possibleConstructorReturn(this, (ControlsProp.__proto__ || Object.getPrototypeOf(ControlsProp)).call(this, props));

    _this.handleEvent = function (event) {
      if (_this.props.handler) {
        _this.props.handler(event);
      }

      if (_this.state.controlled) {
        _this.setState({ value: _this.state.value });
      } else {
        _this.setState({ value: event.target[_this.props.eventTargetPropName] });
      }
    };

    _this.state = {
      controlled: props.value !== undefined,
      value: _this.defaultValue()
    };
    return _this;
  }

  _createClass(ControlsProp, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.configureHandler(nextProps);
    }
  }, {
    key: "defaultValue",
    value: function defaultValue() {
      var _props = this.props,
          defaultValue = _props.defaultValue,
          value = _props.value;


      return value !== undefined ? value : defaultValue;
    }
  }, {
    key: "configureHandler",
    value: function configureHandler(props) {
      if (!props.mounted) {
        return;
      }

      if (this.state.dispose) {
        this.state.dispose();
      }

      if (!props.handler) {
        return;
      }

      throwIfNoHIGMethod(this.props, this.props.listener);
      this.setState({
        dispose: props.higInstance[props.listener](this.handleEvent)
      });
    }
  }, {
    key: "renderedValue",
    value: function renderedValue() {
      return this.props.value !== undefined ? this.props.value : this.state.value;
    }
  }, {
    key: "render",
    value: function render() {
      if (!this.props.mounted) {
        return null;
      }

      if (this.state.value === undefined) {
        return null;
      }

      if (this.props.children) {
        this.props.children(this.props.higInstance, this.renderedValue());
      } else {
        throwIfNoHIGMethod(this.props, this.props.setter);
        this.props.higInstance[this.props.setter](this.renderedValue());
      }

      return null;
    }
  }]);

  return ControlsProp;
}(Component);

ControlsProp.propTypes = {
  defaultValue: PropTypes.any,
  eventTargetPropName: PropTypes.string,
  handler: PropTypes.func,
  higInstance: HIGPropTypes.higInstance,
  listener: PropTypes.string,
  mounted: PropTypes.bool.isRequired,
  setter: PropTypes.string,
  value: PropTypes.any,
  children: PropTypes.func
};
ControlsProp.defaultProps = {
  children: undefined,
  defaultValue: "",
  eventTargetPropName: "value",
  handler: undefined,
  listener: undefined,
  setter: undefined,
  value: undefined
};


export default ControlsProp;
ControlsProp.__docgenInfo = {
  "description": "",
  "displayName": "ControlsProp",
  "props": {
    "defaultValue": {
      "type": {
        "name": "any"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "\"\"",
        "computed": false
      }
    },
    "eventTargetPropName": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "\"value\"",
        "computed": false
      }
    },
    "handler": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "higInstance": {
      "type": {
        "name": "custom",
        "raw": "HIGPropTypes.higInstance"
      },
      "required": false,
      "description": ""
    },
    "listener": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "mounted": {
      "type": {
        "name": "bool"
      },
      "required": true,
      "description": ""
    },
    "setter": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "value": {
      "type": {
        "name": "any"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "children": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};