var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { Themes } from "hig-vanilla";
import "hig-vanilla/lib/hig.css";
import HIGPropTypes from "./HIGPropTypes";

var HIGAdapter = function (_Component) {
  _inherits(HIGAdapter, _Component);

  function HIGAdapter(props) {
    _classCallCheck(this, HIGAdapter);

    var _this = _possibleConstructorReturn(this, (HIGAdapter.__proto__ || Object.getPrototypeOf(HIGAdapter)).call(this, props));

    _this.onMount = function () {
      _this.setState({ mounted: true });
    };

    _this.setEl = function (el) {
      _this._el = el;
    };

    _this.state = {
      higInstance: props.higInstance || new props.HIGConstructor({}),
      mounted: false
    };
    return _this;
  }

  _createClass(HIGAdapter, [{
    key: "getChildContext",
    value: function getChildContext() {
      return {
        higTheme: this.props.higTheme || this.context.higTheme
      };
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!this.context.higParent) {
        this._mount = this._el.parentNode;
        this._anchor = document.createComment("HIG" + this.props.displayName + "-Anchor");
        // Place this component's element with an anchor comment
        this._mount.replaceChild(this._anchor, this._el);
        // Mount the hig component at the comment
        this.state.higInstance.mount(this._mount, this._anchor);
        this.onMount();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this._anchor) {
        // Replace the anchor comment with this component's div
        this._mount.replaceChild(this._el, this._anchor);
      }
      this.state.higInstance.unmount();
    }
  }, {
    key: "renderedTheme",
    value: function renderedTheme() {
      return this.props.higTheme || this.context.higTheme;
    }
  }, {
    key: "render",
    value: function render() {
      if (this.state.higInstance && this.renderedTheme()) {
        this.state.higInstance.setTheme(this.renderedTheme());
      }

      return React.createElement("hig-" + this.props.displayName.toLowerCase(), { ref: this.setEl }, this.props.children({
        higInstance: this.state.higInstance,
        mounted: this.state.mounted,
        higParent: this.context.higParent,
        onMount: this.onMount,
        displayName: this.props.displayName
      }));
    }
  }]);

  return HIGAdapter;
}(Component);

HIGAdapter.propTypes = {
  children: PropTypes.func,
  HIGConstructor: PropTypes.func.isRequired,
  displayName: PropTypes.string.isRequired,
  higInstance: HIGPropTypes.higInstance,
  higTheme: PropTypes.oneOf(Themes.AvailableThemes)
};
HIGAdapter.contextTypes = {
  higParent: PropTypes.object,
  higTheme: PropTypes.oneOf(Themes.AvailableThemes)
};
HIGAdapter.childContextTypes = {
  higTheme: PropTypes.oneOf(Themes.AvailableThemes)
};
HIGAdapter.defaultProps = {
  children: function children() {},
  higInstance: undefined
};


export default HIGAdapter;
HIGAdapter.__docgenInfo = {
  "description": "",
  "displayName": "HIGAdapter",
  "props": {
    "children": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "HIGConstructor": {
      "type": {
        "name": "func"
      },
      "required": true,
      "description": ""
    },
    "displayName": {
      "type": {
        "name": "string"
      },
      "required": true,
      "description": ""
    },
    "higInstance": {
      "type": {
        "name": "custom",
        "raw": "HIGPropTypes.higInstance"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "higTheme": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "Themes.AvailableThemes"
      },
      "required": false,
      "description": ""
    }
  }
};