var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import { Component } from "react";
import PropTypes from "prop-types";
import throwIfNoHIGMethod from "./throwIfNoHIGMethod";
import HIGPropTypes from "./HIGPropTypes";

var MapsPropToMethod = function (_Component) {
  _inherits(MapsPropToMethod, _Component);

  function MapsPropToMethod(props) {
    _classCallCheck(this, MapsPropToMethod);

    var _this = _possibleConstructorReturn(this, (MapsPropToMethod.__proto__ || Object.getPrototypeOf(MapsPropToMethod)).call(this, props));

    _this.state = { unset: props.value === undefined };
    return _this;
  }

  _createClass(MapsPropToMethod, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== undefined) {
        this.setState({ unset: false });
      }
    }
  }, {
    key: "throwIfNoSetter",
    value: function throwIfNoSetter() {
      if (this.props.higInstance[this.props.setter] === undefined) {
        throw new TypeError(this.props.displayName + " has no method '" + this.props.setter + "'");
      }
    }
  }, {
    key: "render",
    value: function render() {
      if (!this.props.mounted) {
        return null;
      }

      if (this.props.value === undefined && this.state.unset) {
        return null;
      }

      if (this.props.children) {
        this.props.children(this.props.higInstance, this.props.value);
      } else {
        throwIfNoHIGMethod(this.props, this.props.setter);
        this.props.higInstance[this.props.setter](this.props.value);
      }

      return null;
    }
  }]);

  return MapsPropToMethod;
}(Component);

MapsPropToMethod.propTypes = {
  children: PropTypes.func,
  displayName: PropTypes.string.isRequired,
  higInstance: HIGPropTypes.higInstance,
  mounted: PropTypes.bool.isRequired,
  setter: PropTypes.string,
  value: PropTypes.any // eslint-disable-line react/forbid-prop-types
};
MapsPropToMethod.defaultProps = {
  children: undefined,
  setter: undefined,
  value: undefined
};


export default MapsPropToMethod;
MapsPropToMethod.__docgenInfo = {
  "description": "",
  "displayName": "MapsPropToMethod",
  "props": {
    "children": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "displayName": {
      "type": {
        "name": "string"
      },
      "required": true,
      "description": ""
    },
    "higInstance": {
      "type": {
        "name": "custom",
        "raw": "HIGPropTypes.higInstance"
      },
      "required": false,
      "description": ""
    },
    "mounted": {
      "type": {
        "name": "bool"
      },
      "required": true,
      "description": ""
    },
    "setter": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "value": {
      "type": {
        "name": "any"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};