var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";

import { Modal as VanillaModal, Button as VanillaButton } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod, MapsEventListener, MountsAnyChild } from "./HIGAdapter";
import Button from "./ButtonAdapter";

var ModalAdapter = function (_Component) {
  _inherits(ModalAdapter, _Component);

  function ModalAdapter(props) {
    _classCallCheck(this, ModalAdapter);

    var _this = _possibleConstructorReturn(this, (ModalAdapter.__proto__ || Object.getPrototypeOf(ModalAdapter)).call(this, props));

    _this.mapButtons = function (higInstance, nextButtons) {
      _this.buttons.forEach(function (button) {
        button.unmount();
      });

      _this.buttons = nextButtons.map(function (buttonProps) {
        var button = new VanillaButton(buttonProps);

        higInstance.addButton(button);

        return button;
      });
    };

    _this.buttons = [];
    return _this;
  }

  _createClass(ModalAdapter, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        HIGAdapter,
        _extends({
          displayName: "Modal",
          HIGConstructor: VanillaModal
        }, this.props),
        function (adapterProps) {
          return React.createElement(
            "div",
            null,
            React.createElement(MapsPropToMethod, _extends({
              setter: "setBody",
              value: _this2.props.body
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setStyle",
              value: _this2.props.style
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setTitle",
              value: _this2.props.title
            }, adapterProps)),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.open }, adapterProps),
              function (instance, value) {
                return value ? instance.open() : instance.close();
              }
            ),
            React.createElement(MapsEventListener, _extends({
              listener: "onCloseClick",
              handler: _this2.props.onCloseClick
            }, adapterProps)),
            React.createElement(MapsEventListener, _extends({
              listener: "onOverlayClick",
              handler: _this2.props.onOverlayClick
            }, adapterProps)),
            React.createElement(
              MountsAnyChild,
              _extends({ mounter: "addSlot" }, adapterProps),
              _this2.props.children
            ),
            React.createElement(
              MapsPropToMethod,
              _extends({ value: _this2.props.buttons }, adapterProps),
              _this2.mapButtons
            )
          );
        }
      );
    }
  }]);

  return ModalAdapter;
}(Component);

export default ModalAdapter;


ModalAdapter.propTypes = {
  /**
   * Text or html string content of the modal
   */
  body: PropTypes.string,
  /**
   * An array of props supported by the Button component
   */
  buttons: PropTypes.arrayOf(PropTypes.shape(Button.propTypes)),
  /**
   * Supports adding any dom content to the body of the modal
   */
  children: PropTypes.node,
  /**
   * Triggers when you click the close button
   */
  onCloseClick: PropTypes.func,
  /**
   * Triggers when you click the overlay behind the modal
   */
  onOverlayClick: PropTypes.func,
  /**
   * Modal is visible when true
   */
  open: PropTypes.bool,
  /**
   * Style of the modal shell
   */
  style: PropTypes.oneOf(VanillaModal.AvailableStyles),
  /**
   * Title of the modal
   */
  title: PropTypes.string
};

ModalAdapter.defaultProps = {
  buttons: []
};
ModalAdapter.__docgenInfo = {
  "description": "",
  "displayName": "ModalAdapter",
  "props": {
    "body": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Text or html string content of the modal"
    },
    "buttons": {
      "type": {
        "name": "arrayOf",
        "value": {
          "name": "shape",
          "value": "Button.propTypes",
          "computed": true
        }
      },
      "required": false,
      "description": "An array of props supported by the Button component",
      "defaultValue": {
        "value": "[]",
        "computed": false
      }
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Supports adding any dom content to the body of the modal"
    },
    "onCloseClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Triggers when you click the close button"
    },
    "onOverlayClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Triggers when you click the overlay behind the modal"
    },
    "open": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Modal is visible when true"
    },
    "style": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaModal.AvailableStyles"
      },
      "required": false,
      "description": "Style of the modal shell"
    },
    "title": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Title of the modal"
    }
  }
};