var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { ProgressRing } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod } from "./HIGAdapter";

var ProgressRingAdapter = function (_Component) {
  _inherits(ProgressRingAdapter, _Component);

  function ProgressRingAdapter() {
    _classCallCheck(this, ProgressRingAdapter);

    return _possibleConstructorReturn(this, (ProgressRingAdapter.__proto__ || Object.getPrototypeOf(ProgressRingAdapter)).apply(this, arguments));
  }

  _createClass(ProgressRingAdapter, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        HIGAdapter,
        _extends({}, this.props, {
          displayName: "ProgressRing",
          HIGConstructor: ProgressRing
        }),
        function (higProps) {
          return React.createElement(
            "div",
            null,
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.percentComplete,
              setter: "setPercentComplete"
            }, higProps)),
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.size,
              setter: "setSize"
            }, higProps))
          );
        }
      );
    }
  }]);

  return ProgressRingAdapter;
}(Component);

export default ProgressRingAdapter;


ProgressRingAdapter.propTypes = {
  /**
   * An integer from 0 to 100 representing the percent the delayed operation has completed
   */
  percentComplete: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  /**
   * {xs, s, m, l} the size of the progress indicator
   */
  size: PropTypes.oneOf(ProgressRing.AvailableSizes)
};
ProgressRingAdapter.__docgenInfo = {
  "description": "",
  "displayName": "ProgressRingAdapter",
  "props": {
    "percentComplete": {
      "type": {
        "name": "union",
        "value": [{
          "name": "string"
        }, {
          "name": "number"
        }]
      },
      "required": false,
      "description": "An integer from 0 to 100 representing the percent the delayed operation has completed"
    },
    "size": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "ProgressRing.AvailableSizes"
      },
      "required": false,
      "description": "{xs, s, m, l} the size of the progress indicator"
    }
  }
};