var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { Spacer as VanillaSpacer } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod, MountsAnyChild } from "./HIGAdapter";

var SpacerAdapter = function (_Component) {
  _inherits(SpacerAdapter, _Component);

  function SpacerAdapter() {
    _classCallCheck(this, SpacerAdapter);

    return _possibleConstructorReturn(this, (SpacerAdapter.__proto__ || Object.getPrototypeOf(SpacerAdapter)).apply(this, arguments));
  }

  _createClass(SpacerAdapter, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        HIGAdapter,
        _extends({}, this.props, {
          displayName: "Spacer",
          HIGConstructor: VanillaSpacer
        }),
        function (adapterProps) {
          return React.createElement(
            "div",
            null,
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.inset,
              setter: "setInset"
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.type,
              setter: "setType"
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.width,
              setter: "setWidth"
            }, adapterProps)),
            React.createElement(
              MountsAnyChild,
              _extends({ mounter: "addSlot" }, adapterProps),
              _this2.props.children
            )
          );
        }
      );
    }
  }]);

  return SpacerAdapter;
}(Component);

export default SpacerAdapter;


SpacerAdapter.propTypes = {
  /**
   * Inset width of the spacer
   */
  inset: PropTypes.oneOf(VanillaSpacer.AvailableSizes),
  /**
   * Type of the spacer ('stack' or 'inline')
   */
  type: PropTypes.oneOf(VanillaSpacer.AvailableTypes),
  /**
   * Width of the spacer (vertical if type is 'stack', horizontal if type is 'inline'
   */
  width: PropTypes.oneOf(VanillaSpacer.AvailableSizes),
  /**
   * Content to render within the spacer
   */
  children: PropTypes.node
};
SpacerAdapter.__docgenInfo = {
  "description": "",
  "displayName": "SpacerAdapter",
  "props": {
    "inset": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaSpacer.AvailableSizes"
      },
      "required": false,
      "description": "Inset width of the spacer"
    },
    "type": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaSpacer.AvailableTypes"
      },
      "required": false,
      "description": "Type of the spacer ('stack' or 'inline')"
    },
    "width": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaSpacer.AvailableSizes"
      },
      "required": false,
      "description": "Width of the spacer (vertical if type is 'stack', horizontal if type is 'inline'"
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Content to render within the spacer"
    }
  }
};