var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import { Table as VanillaTable } from "hig-vanilla";

import HIGAdapter, { MapsPropToMethod, MountsHIGChildList, MountsHIGChild } from "../HIGAdapter";

import TableHeadAdapter from "./TableHeadAdapter";

function sortChildren(children) {
  return {
    tableHead: children.find(function (child) {
      return child.type === TableHeadAdapter;
    }),
    otherChildren: children.filter(function (child) {
      return ![TableHeadAdapter].includes(child.type);
    })
  };
}
function TableAdapter(props) {
  var _sortChildren = sortChildren(React.Children.toArray(props.children)),
      tableHead = _sortChildren.tableHead,
      otherChildren = _sortChildren.otherChildren;

  return React.createElement(
    HIGAdapter,
    _extends({ displayName: "Table", HIGConstructor: VanillaTable }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MapsPropToMethod, _extends({
          value: props.density,
          setter: "setDensity"
        }, adapterProps)),
        React.createElement(
          MountsHIGChild,
          adapterProps,
          tableHead
        ),
        React.createElement(
          MountsHIGChildList,
          adapterProps,
          otherChildren
        )
      );
    }
  );
}

export default TableAdapter;
TableAdapter.__docgenInfo = {
  "description": "",
  "displayName": "TableAdapter"
};