var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import { Table as VanillaTable } from "hig-vanilla";
import PropTypes from "prop-types";

import HIGAdapter, { MapsPropToMethod, MountedByHIGParent, MountsHIGChildList } from "../HIGAdapter";

function TableRowAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "TableRow",
      HIGConstructor: VanillaTable._partials.TableRow
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.selected }, adapterProps),
          function (instance, value) {
            return value ? instance.select() : instance.deselect();
          }
        ),
        React.createElement(MountedByHIGParent, _extends({ mounter: "addTableRow" }, adapterProps)),
        React.createElement(
          MountsHIGChildList,
          adapterProps,
          props.children
        )
      );
    }
  );
}

TableRowAdapter.propTypes = {
  selected: PropTypes.bool,
  children: PropTypes.node
};

TableRowAdapter.defaultProps = {
  selected: undefined,
  children: undefined
};

export default TableRowAdapter;
TableRowAdapter.__docgenInfo = {
  "description": "",
  "displayName": "TableRowAdapter",
  "props": {
    "selected": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};