var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { Table as VanillaTable } from "hig-vanilla";

import HIGAdapter, { MapsPropToMethod, MountedByHIGParentList } from "../HIGAdapter";

function TextCellAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({}, props, {
      displayName: "TextCell",
      HIGConstructor: VanillaTable._partials.TableRow._partials.TextCell
    }),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParentList, _extends({ mounter: "addCell" }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.text,
          setter: "setText"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.detail,
          setter: "setDetail"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.alignment,
          setter: "setAlignment"
        }, adapterProps))
      );
    }
  );
}

TextCellAdapter.propTypes = {
  text: PropTypes.string,
  detail: PropTypes.string,
  alignment: PropTypes.oneOf(VanillaTable._partials.TableRow._partials.TextCell.AvailableAlignments)
};

TextCellAdapter.defaultProps = {
  text: undefined,
  detail: undefined,
  alignment: undefined
};

export default TextCellAdapter;
TextCellAdapter.__docgenInfo = {
  "description": "",
  "displayName": "TextCellAdapter",
  "props": {
    "text": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "detail": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "alignment": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaTable._partials.TableRow._partials.TextCell.AvailableAlignments"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};