var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import { TextCellContent as VanillaTextCellContent } from "hig-vanilla";
import PropTypes from "prop-types";

import HIGAdapter, { MapsPropToMethod } from "../HIGAdapter";

var TextCellContentAdapter = function (_Component) {
  _inherits(TextCellContentAdapter, _Component);

  function TextCellContentAdapter() {
    _classCallCheck(this, TextCellContentAdapter);

    return _possibleConstructorReturn(this, (TextCellContentAdapter.__proto__ || Object.getPrototypeOf(TextCellContentAdapter)).apply(this, arguments));
  }

  _createClass(TextCellContentAdapter, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        HIGAdapter,
        _extends({
          displayName: "TextCellContent",
          HIGConstructor: VanillaTextCellContent
        }, this.props),
        function (adapterProps) {
          return React.createElement(
            "div",
            null,
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.text,
              setter: "setText"
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.detail,
              setter: "setDetail"
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              value: _this2.props.alignment,
              setter: "setAlignment"
            }, adapterProps))
          );
        }
      );
    }
  }]);

  return TextCellContentAdapter;
}(Component);

export default TextCellContentAdapter;


TextCellContentAdapter.propTypes = {
  /**
   * Sets {String} text in cell
   */
  text: PropTypes.string,
  /**
   * Sets {String} supporting text for cell in body of table
   */
  detail: PropTypes.string,
  /**
   * Sets {String} text-position of cell
   */
  alignment: PropTypes.oneOf(VanillaTextCellContent.AvailableAlignments)
};
TextCellContentAdapter.__docgenInfo = {
  "description": "",
  "displayName": "TextCellContentAdapter",
  "props": {
    "text": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Sets {String} text in cell"
    },
    "detail": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Sets {String} supporting text for cell in body of table"
    },
    "alignment": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaTextCellContent.AvailableAlignments"
      },
      "required": false,
      "description": "Sets {String} text-position of cell"
    }
  }
};