var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { Table as VanillaTable } from "hig-vanilla";

import HIGAdapter, { MapsPropToMethod, MountedByHIGParentList } from "../HIGAdapter";

function TextHeadCellAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({}, props, {
      displayName: "TextHeadCell",
      HIGConstructor: VanillaTable._partials.TableHead._partials.TextHeadCell
    }),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MountedByHIGParentList, _extends({ mounter: "addCell" }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.text,
          setter: "setText"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.alignment,
          setter: "setAlignment"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.width,
          setter: "setWidth"
        }, adapterProps))
      );
    }
  );
}

TextHeadCellAdapter.propTypes = {
  text: PropTypes.string,
  alignment: PropTypes.string,
  width: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
};

TextHeadCellAdapter.defaultProps = {
  text: undefined,
  alignment: undefined,
  width: undefined
};

export default TextHeadCellAdapter;
TextHeadCellAdapter.__docgenInfo = {
  "description": "",
  "displayName": "TextHeadCellAdapter",
  "props": {
    "text": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "alignment": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "width": {
      "type": {
        "name": "union",
        "value": [{
          "name": "string"
        }, {
          "name": "number"
        }]
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    }
  }
};