var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { TextLink as VanillaTextLink } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod, MapsEventListener } from "./HIGAdapter";

var TextLinkAdapter = function (_Component) {
  _inherits(TextLinkAdapter, _Component);

  function TextLinkAdapter() {
    _classCallCheck(this, TextLinkAdapter);

    return _possibleConstructorReturn(this, (TextLinkAdapter.__proto__ || Object.getPrototypeOf(TextLinkAdapter)).apply(this, arguments));
  }

  _createClass(TextLinkAdapter, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        HIGAdapter,
        _extends({}, this.props, {
          displayName: "TextLink",
          HIGConstructor: VanillaTextLink
        }),
        function (adapterProps) {
          return React.createElement(
            "span",
            null,
            React.createElement(MapsEventListener, _extends({
              listener: "onClick",
              handler: _this2.props.onClick
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setHref",
              value: _this2.props.href
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setType",
              value: _this2.props.type
            }, adapterProps)),
            React.createElement(MapsPropToMethod, _extends({
              setter: "setText",
              value: _this2.props.text
            }, adapterProps))
          );
        }
      );
    }
  }]);

  return TextLinkAdapter;
}(Component);

export default TextLinkAdapter;


TextLinkAdapter.propTypes = {
  /**
   * Sets the link url or path
   */
  href: PropTypes.string,
  /**
   * Triggers when you click the link
   */
  onClick: PropTypes.func,
  /**
   * Sets the text and alt-text of the link
   */
  text: PropTypes.string.isRequired,
  /**
   * Specifies type of link
   */
  type: PropTypes.oneOf(VanillaTextLink.AvailableTypes)
};
TextLinkAdapter.__docgenInfo = {
  "description": "",
  "displayName": "TextLinkAdapter",
  "props": {
    "href": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Sets the link url or path"
    },
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Triggers when you click the link"
    },
    "text": {
      "type": {
        "name": "string"
      },
      "required": true,
      "description": "Sets the text and alt-text of the link"
    },
    "type": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaTextLink.AvailableTypes"
      },
      "required": false,
      "description": "Specifies type of link"
    }
  }
};