var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";

import { Tooltip as VanillaTooltip } from "hig-vanilla";
import HIGAdapter, { MapsPropToMethod, MapsEventListener, MountsAnyChild } from "./HIGAdapter";

function TooltipAdapter(props) {
  return React.createElement(
    HIGAdapter,
    _extends({
      displayName: "Tooltip",
      HIGConstructor: VanillaTooltip
    }, props),
    function (adapterProps) {
      return React.createElement(
        "div",
        null,
        React.createElement(MapsPropToMethod, _extends({
          value: props.anchorPoint,
          setter: "setAnchorPoint"
        }, adapterProps)),
        React.createElement(MapsPropToMethod, _extends({
          value: props.content,
          setter: "setContent"
        }, adapterProps)),
        React.createElement(
          MapsPropToMethod,
          _extends({ value: props.open }, adapterProps),
          function (instance, value) {
            return value ? instance.open() : instance.close();
          }
        ),
        React.createElement(MapsEventListener, _extends({
          listener: "onClickOutside",
          handler: props.onClickOutside
        }, adapterProps)),
        React.createElement(
          MountsAnyChild,
          _extends({ mounter: "addTarget" }, adapterProps),
          props.children
        )
      );
    }
  );
}

TooltipAdapter.propTypes = {
  anchorPoint: PropTypes.oneOf(VanillaTooltip.AvailableAnchorPoints),
  onClickOutside: PropTypes.func,
  open: PropTypes.bool,
  target: PropTypes.node,
  content: PropTypes.string,
  children: PropTypes.node
};

export default TooltipAdapter;
TooltipAdapter.__docgenInfo = {
  "description": "",
  "displayName": "TooltipAdapter",
  "props": {
    "anchorPoint": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaTooltip.AvailableAnchorPoints"
      },
      "required": false,
      "description": ""
    },
    "onClickOutside": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": ""
    },
    "open": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": ""
    },
    "target": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": ""
    },
    "content": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": ""
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": ""
    }
  }
};