var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { ExpandingFilterSection as VanillaExpandingFilterSection } from "hig-vanilla";
import ExpandingFilterSectionAdapter from "../../adapters/ExpandingFilterSectionAdapter";

var ExpandingFilterSection = function (_Component) {
  _inherits(ExpandingFilterSection, _Component);

  function ExpandingFilterSection(props) {
    _classCallCheck(this, ExpandingFilterSection);

    var _this = _possibleConstructorReturn(this, (ExpandingFilterSection.__proto__ || Object.getPrototypeOf(ExpandingFilterSection)).call(this, props));

    _this.toggleExpanded = function (event) {
      event.preventDefault();
      _this.setState({ expanded: !_this.state.expanded });
    };

    _this.state = {
      expanded: false
    };
    return _this;
  }

  _createClass(ExpandingFilterSection, [{
    key: "render",
    value: function render() {
      return React.createElement(ExpandingFilterSectionAdapter, _extends({}, this.props, {
        onClick: this.toggleExpanded,
        open: this.state.expanded
      }));
    }
  }]);

  return ExpandingFilterSection;
}(Component);

export default ExpandingFilterSection;


ExpandingFilterSection.propTypes = {
  /**
   * Content to be shown when section is open
   */
  children: PropTypes.node,
  /**
   * Short text describing the content
   */
  label: PropTypes.string,
  /**
   * {s, m} size of the expanding filter section label
   */
  size: PropTypes.oneOf(VanillaExpandingFilterSection.AvailableSizes)
};
ExpandingFilterSection.__docgenInfo = {
  "description": "",
  "displayName": "ExpandingFilterSection",
  "props": {
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Content to be shown when section is open"
    },
    "label": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Short text describing the content"
    },
    "size": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaExpandingFilterSection.AvailableSizes"
      },
      "required": false,
      "description": "{s, m} size of the expanding filter section label"
    }
  }
};