var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import PropTypes from "prop-types";
import React, { Component } from "react";
import { Flyout as VanillaFlyout } from "hig-vanilla";
import FlyoutAdapter from "../../adapters/FlyoutAdapter";

var Flyout = function (_Component) {
  _inherits(Flyout, _Component);

  function Flyout(props) {
    _classCallCheck(this, Flyout);

    var _this = _possibleConstructorReturn(this, (Flyout.__proto__ || Object.getPrototypeOf(Flyout)).call(this, props));

    _this.closeFlyout = function () {
      _this.setState({ open: false });
      _this.props.onClickOutside();
    };

    _this.toggleFlyout = function () {
      _this.setState({ open: !_this.state.open });
    };

    _this.state = {
      open: false
    };
    return _this;
  }

  _createClass(Flyout, [{
    key: "render",
    value: function render() {
      var target = this.props.children ? React.cloneElement(this.props.children, { onClick: this.toggleFlyout }) : null;
      return React.createElement(
        FlyoutAdapter,
        {
          anchorPoint: this.props.anchorPoint,
          open: typeof this.props.open === "boolean" ? this.props.open : this.state.open,
          onClickOutside: this.closeFlyout,
          content: this.props.content,
          maxHeight: this.props.maxHeight
        },
        target
      );
    }
  }]);

  return Flyout;
}(Component);

export default Flyout;


Flyout.defaultProps = {
  onClickOutside: function onClickOutside() {}
};

Flyout.propTypes = {
  /**
   * Where the flyout will be anchored relative to target
   */
  anchorPoint: PropTypes.oneOf(VanillaFlyout.AvailableAnchorPoints),
  /**
   * Target component to open the flyout
   */
  children: PropTypes.node,
  /**
   * Content for the flyout
   */
  content: PropTypes.node,
  /**
   * Max height of the flyout content, in pixels
   */
  maxHeight: PropTypes.number,
  /**
   * Function to call when clicking outside of the flyout
   */
  onClickOutside: PropTypes.func,
  /**
   * When provided, it overrides the flyout's open state
   */
  open: PropTypes.bool
};
Flyout.__docgenInfo = {
  "description": "",
  "displayName": "Flyout",
  "props": {
    "anchorPoint": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaFlyout.AvailableAnchorPoints"
      },
      "required": false,
      "description": "Where the flyout will be anchored relative to target"
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Target component to open the flyout"
    },
    "content": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Content for the flyout"
    },
    "maxHeight": {
      "type": {
        "name": "number"
      },
      "required": false,
      "description": "Max height of the flyout content, in pixels"
    },
    "onClickOutside": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Function to call when clicking outside of the flyout",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "open": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "When provided, it overrides the flyout's open state"
    }
  }
};