var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import PasswordFieldAdapter from "../../../adapters/FormElements/PasswordFieldAdapter";

var PasswordField = function (_Component) {
  _inherits(PasswordField, _Component);

  function PasswordField(props) {
    _classCallCheck(this, PasswordField);

    var _this = _possibleConstructorReturn(this, (PasswordField.__proto__ || Object.getPrototypeOf(PasswordField)).call(this, props));

    _this.handleBlur = function (event) {
      _this.props.onBlur(event);
      _this.setState({ hasFocus: false });
    };

    _this.handleFocus = function (event) {
      _this.props.onFocus(event);
      _this.setState({ hasFocus: true });
    };

    _this.handlePasswordHideButtonClick = function (event) {
      event.stopPropagation();
      event.preventDefault();
      _this.setState({ showPassword: false });
    };

    _this.handlePasswordRevealButtonClick = function (event) {
      event.stopPropagation();
      event.preventDefault();
      _this.setState({ showPassword: true });
    };

    _this.state = {
      showPassword: false,
      hasFocus: false
    };
    return _this;
  }

  _createClass(PasswordField, [{
    key: "render",
    value: function render() {
      return React.createElement(PasswordFieldAdapter, _extends({}, this.props, {
        onBlur: this.handleBlur,
        onFocus: this.handleFocus,
        onPasswordHideButtonClick: this.handlePasswordHideButtonClick,
        onPasswordRevealButtonClick: this.handlePasswordRevealButtonClick,
        revealPassword: this.state.showPassword,
        showPasswordHideButton: this.state.hasFocus && this.state.showPassword,
        showPasswordRevealButton: this.state.hasFocus && !this.state.showPassword
      }));
    }
  }]);

  return PasswordField;
}(Component);

export default PasswordField;


PasswordField.propTypes = {
  /**
   * Disable the field, preventing user interaction
   */
  disabled: PropTypes.bool,
  /**
   * Initial value of the field
   */
  initialValue: PropTypes.string,
  /**
   * A short description or suggestion
   */
  instructions: PropTypes.string,
  /**
   * Describes what the field controls
   */
  label: PropTypes.string,
  /**
   * Set on the element's name attribute
   */
  name: PropTypes.string,
  /**
   * Called when user moves focus away from the field
   */
  onBlur: PropTypes.func,
  /**
   * Called when user enters a new value and moves focus away from the field
   */
  onChange: PropTypes.func,
  /**
   * Called when user moves focus onto the field
   */
  onFocus: PropTypes.func,
  /**
   * Called when user enters a new value
   */
  onInput: PropTypes.func,
  /**
   * Data entry suggestions or formatting examples
   */
  placeholder: PropTypes.string,
  /**
   * Indicates a field must be filled before the form may be completed
   */
  required: PropTypes.string,
  /**
   * Controlled value of the field
   */
  value: PropTypes.string
};

PasswordField.defaultProps = {
  onBlur: function onBlur() {},
  onFocus: function onFocus() {},
  onChange: function onChange() {},
  onInput: function onInput() {}
};
PasswordField.__docgenInfo = {
  "description": "",
  "displayName": "PasswordField",
  "props": {
    "disabled": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Disable the field, preventing user interaction"
    },
    "initialValue": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Initial value of the field"
    },
    "instructions": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "A short description or suggestion"
    },
    "label": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Describes what the field controls"
    },
    "name": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Set on the element's name attribute"
    },
    "onBlur": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user moves focus away from the field",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onChange": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user enters a new value and moves focus away from the field",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onFocus": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user moves focus onto the field",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onInput": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user enters a new value",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "placeholder": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Data entry suggestions or formatting examples"
    },
    "required": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Indicates a field must be filled before the form may be completed"
    },
    "value": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Controlled value of the field"
    }
  }
};