var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";

import GlobalNavAdapter from "../../../adapters/GlobalNav/GlobalNavAdapter";
import TopNavAdapter from "../../../adapters/GlobalNav/TopNav/TopNavAdapter";
import Search from "./TopNav/Search";
import SubNavAdapter from "../../../adapters/GlobalNav/SubNav/SubNavAdapter";
import HelpAdapter from "../../../adapters/GlobalNav/TopNav/HelpAdapter";
import GroupAdapter from "../../../adapters/GlobalNav/TopNav/GroupAdapter";
import OptionAdapter from "../../../adapters/GlobalNav/TopNav/OptionAdapter";
import Profile from "./TopNav/Profile";
import SideNav from "./SideNav";
import Tabs from "./SubNav/Tabs";
import ProjectAccountSwitcher from "./TopNav/ProjectAccountSwitcher";
import Notifications from "./TopNav/Notifications";
import Notification from "./TopNav/Notification";

var GlobalNav = function (_Component) {
  _inherits(GlobalNav, _Component);

  function GlobalNav(props) {
    _classCallCheck(this, GlobalNav);

    var _this = _possibleConstructorReturn(this, (GlobalNav.__proto__ || Object.getPrototypeOf(GlobalNav)).call(this, props));

    _this.handleHamburgerClick = function (event) {
      _this.props.onHamburgerClick(event);
      _this.setState({ sideNavOpen: !_this.state.sideNavOpen });
    };

    _this.renderTab = function (submodule) {
      return React.createElement(Tabs.Tab, { id: submodule.id, label: submodule.title, key: submodule.id });
    };

    _this.state = {
      sideNavOpen: _this.props.sideNavOpenByDefault || false
    };
    return _this;
  }

  _createClass(GlobalNav, [{
    key: "showProjectAccountSwitcher",
    value: function showProjectAccountSwitcher() {
      var topNav = this.props.topNav || {};
      var projectAccountSwitcher = topNav.projectAccountSwitcher || {};
      var accounts = projectAccountSwitcher.accounts || [];
      var projects = projectAccountSwitcher.projects || [];
      return accounts.length > 0 || projects.length > 0;
    }
  }, {
    key: "showSearch",
    value: function showSearch() {
      return this.props.topNav.search;
    }
  }, {
    key: "showHelp",
    value: function showHelp() {
      return this.props.topNav.help && this.props.topNav.help.groups && this.props.topNav.help.groups.length > 0;
    }
  }, {
    key: "showNotifications",
    value: function showNotifications() {
      return this.props.topNav.notifications && this.props.topNav.notifications.notifications;
    }
  }, {
    key: "showProfile",
    value: function showProfile() {
      return this.props.topNav.profile !== undefined;
    }
  }, {
    key: "renderedSideNavOpen",
    value: function renderedSideNavOpen() {
      if (this.props.sideNavOpen !== undefined) {
        return this.props.sideNavOpen;
      }
      return this.state.sideNavOpen;
    }
  }, {
    key: "renderedActiveModule",
    value: function renderedActiveModule() {
      var _this2 = this;

      var activeSubmodule = this.props.submodules.find(function (s) {
        return s.id === _this2.props.activeModuleId;
      }) || {};
      var activeModule = this.props.modules.find(function (m) {
        return m.id === activeSubmodule.moduleId || m.id === _this2.props.activeModuleId;
      });

      if (activeModule === undefined) {
        return null;
      }

      activeModule.submodules = this.props.submodules.filter(function (s) {
        return s.moduleId === activeModule.id;
      });
      return activeModule;
    }
  }, {
    key: "render",


    /* eslint-disable react/no-array-index-key */
    value: function render() {
      var activeModule = this.renderedActiveModule();

      return React.createElement(
        "div",
        null,
        React.createElement(
          GlobalNavAdapter,
          { sideNavOpen: this.renderedSideNavOpen() },
          React.createElement(
            TopNavAdapter,
            _extends({
              onHamburgerClick: this.handleHamburgerClick
            }, this.props.topNav),
            this.showSearch() && React.createElement(Search, this.props.topNav.search),
            this.showProjectAccountSwitcher() ? React.createElement(ProjectAccountSwitcher, this.props.topNav.projectAccountSwitcher) : null,
            this.showHelp() ? React.createElement(
              HelpAdapter,
              this.props.topNav.help,
              (this.props.topNav.help.groups || []).map(function (groupProps, i) {
                return React.createElement(
                  GroupAdapter,
                  _extends({ key: i }, groupProps),
                  (groupProps.options || []).map(function (optionProps) {
                    return React.createElement(OptionAdapter, _extends({ key: optionProps.name }, optionProps));
                  })
                );
              })
            ) : null,
            this.showNotifications() ? React.createElement(
              Notifications,
              this.props.topNav.notifications,
              (this.props.topNav.notifications.notifications || []).map(function (notificationProps) {
                return React.createElement(
                  Notification,
                  {
                    unread: notificationProps.unread,
                    key: notificationProps.id,
                    onLinkClick: notificationProps.onLinkClick,
                    id: notificationProps.id,
                    title: notificationProps.title
                  },
                  notificationProps.children ? notificationProps.children : null
                );
              })
            ) : null,
            this.showProfile() ? React.createElement(Profile, this.props.topNav.profile) : null
          ),
          React.createElement(SideNav, _extends({
            activeModuleId: this.props.activeModuleId,
            modules: this.props.modules,
            onModuleChange: this.props.onModuleChange,
            submodules: this.props.submodules
          }, this.props.sideNav)),
          activeModule && this.props.showSubNav ? React.createElement(
            SubNavAdapter,
            {
              moduleIndicatorName: activeModule.title,
              moduleIndicatorIcon: activeModule.icon
            },
            activeModule.submodules.length > 0 ? React.createElement(
              Tabs,
              {
                selectedTabId: this.props.activeModuleId,
                onChange: this.props.onModuleChange
              },
              activeModule.submodules.map(this.renderTab)
            ) : null
          ) : null,
          this.props.children ? this.props.children : null
        )
      );
    }
    /* eslint-enable react/no-array-index-key */

  }]);

  return GlobalNav;
}(Component);

export default GlobalNav;


GlobalNav.propTypes = {
  /**
   * Id of the active module or submodule
   */
  activeModuleId: PropTypes.string,
  /**
   * Page content
   */
  children: PropTypes.node,
  /**
   * Called when the user clicks on the 'hamburger' button in order to toggle the menu
   */
  onHamburgerClick: PropTypes.func,
  /**
   * Called when the user selects a module or submodule
   */
  onModuleChange: PropTypes.func.isRequired,
  /**
   * When true, shows the Subnav below the Topnav
   */
  showSubNav: PropTypes.bool,
  /**
   * When true, Sidenav is open
   */
  sideNavOpen: PropTypes.bool,
  /**
   * Initial open state of the side nav, user actions will override
   */
  sideNavOpenByDefault: PropTypes.bool,
  /**
   * A list of modules to appear in the sidenav
   */
  modules: PropTypes.arrayOf(PropTypes.shape({
    id: PropTypes.string.isRequired,
    title: PropTypes.string.isRequired
  })),
  /**
   * A list of submodules to appear in the sidenav
   */
  submodules: PropTypes.arrayOf(PropTypes.shape({
    id: PropTypes.string.isRequired,
    title: PropTypes.string.isRequired
  })),
  /**
   * Options to configure the Topnav
   */
  topNav: PropTypes.shape({
    logo: PropTypes.string,
    logoLink: PropTypes.string,
    projectAccountSwitcher: PropTypes.shape({
      accounts: PropTypes.array,
      projects: PropTypes.array,
      projectTitle: PropTypes.string,
      accountTitle: PropTypes.string,
      onProjectClick: PropTypes.func,
      onAccountClick: PropTypes.func,
      activeProjectId: PropTypes.string,
      activeAccountId: PropTypes.string
    }),
    help: PropTypes.shape({
      groups: PropTypes.arrayOf(PropTypes.shape({
        name: PropTypes.string
      }))
    }),
    search: PropTypes.shape(Search.propTypes),
    profile: PropTypes.shape(Profile.propTypes)
  }),
  /**
   * Options to configure the Sidenav
   */
  sideNav: PropTypes.shape({
    copyright: PropTypes.string,
    headerLabel: PropTypes.string,
    headerLink: PropTypes.string,
    links: PropTypes.arrayOf(PropTypes.object),
    onHeaderClick: PropTypes.func,
    onSuperHeaderClick: PropTypes.func,
    superHeaderLabel: PropTypes.string,
    superHeaderLink: PropTypes.string
  })
};

GlobalNav.defaultProps = {
  modules: [],
  submodules: [],
  topNav: {},
  sideNav: {},
  onHamburgerClick: function onHamburgerClick() {}
};
GlobalNav.__docgenInfo = {
  "description": "",
  "displayName": "GlobalNav",
  "props": {
    "activeModuleId": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Id of the active module or submodule"
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Page content"
    },
    "onHamburgerClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when the user clicks on the 'hamburger' button in order to toggle the menu",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onModuleChange": {
      "type": {
        "name": "func"
      },
      "required": true,
      "description": "Called when the user selects a module or submodule"
    },
    "showSubNav": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "When true, shows the Subnav below the Topnav"
    },
    "sideNavOpen": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "When true, Sidenav is open"
    },
    "sideNavOpenByDefault": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Initial open state of the side nav, user actions will override"
    },
    "modules": {
      "type": {
        "name": "arrayOf",
        "value": {
          "name": "shape",
          "value": {
            "id": {
              "name": "string",
              "required": true
            },
            "title": {
              "name": "string",
              "required": true
            }
          }
        }
      },
      "required": false,
      "description": "A list of modules to appear in the sidenav",
      "defaultValue": {
        "value": "[]",
        "computed": false
      }
    },
    "submodules": {
      "type": {
        "name": "arrayOf",
        "value": {
          "name": "shape",
          "value": {
            "id": {
              "name": "string",
              "required": true
            },
            "title": {
              "name": "string",
              "required": true
            }
          }
        }
      },
      "required": false,
      "description": "A list of submodules to appear in the sidenav",
      "defaultValue": {
        "value": "[]",
        "computed": false
      }
    },
    "topNav": {
      "type": {
        "name": "shape",
        "value": {
          "logo": {
            "name": "string",
            "required": false
          },
          "logoLink": {
            "name": "string",
            "required": false
          },
          "projectAccountSwitcher": {
            "name": "shape",
            "value": {
              "accounts": {
                "name": "array",
                "required": false
              },
              "projects": {
                "name": "array",
                "required": false
              },
              "projectTitle": {
                "name": "string",
                "required": false
              },
              "accountTitle": {
                "name": "string",
                "required": false
              },
              "onProjectClick": {
                "name": "func",
                "required": false
              },
              "onAccountClick": {
                "name": "func",
                "required": false
              },
              "activeProjectId": {
                "name": "string",
                "required": false
              },
              "activeAccountId": {
                "name": "string",
                "required": false
              }
            },
            "required": false
          },
          "help": {
            "name": "shape",
            "value": {
              "groups": {
                "name": "arrayOf",
                "value": {
                  "name": "shape",
                  "value": {
                    "name": {
                      "name": "string",
                      "required": false
                    }
                  }
                },
                "required": false
              }
            },
            "required": false
          },
          "search": {
            "name": "shape",
            "value": "Search.propTypes",
            "computed": true,
            "required": false
          },
          "profile": {
            "name": "shape",
            "value": "Profile.propTypes",
            "computed": true,
            "required": false
          }
        }
      },
      "required": false,
      "description": "Options to configure the Topnav",
      "defaultValue": {
        "value": "{}",
        "computed": false
      }
    },
    "sideNav": {
      "type": {
        "name": "shape",
        "value": {
          "copyright": {
            "name": "string",
            "required": false
          },
          "headerLabel": {
            "name": "string",
            "required": false
          },
          "headerLink": {
            "name": "string",
            "required": false
          },
          "links": {
            "name": "arrayOf",
            "value": {
              "name": "object"
            },
            "required": false
          },
          "onHeaderClick": {
            "name": "func",
            "required": false
          },
          "onSuperHeaderClick": {
            "name": "func",
            "required": false
          },
          "superHeaderLabel": {
            "name": "string",
            "required": false
          },
          "superHeaderLink": {
            "name": "string",
            "required": false
          }
        }
      },
      "required": false,
      "description": "Options to configure the Sidenav",
      "defaultValue": {
        "value": "{}",
        "computed": false
      }
    }
  }
};