var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import SearchAdapter from "../../../../adapters/GlobalNav/SideNav/SearchAdapter";

var Search = function (_Component) {
  _inherits(Search, _Component);

  function Search(props) {
    _classCallCheck(this, Search);

    var _this = _possibleConstructorReturn(this, (Search.__proto__ || Object.getPrototypeOf(Search)).call(this, props));

    _this.onInput = function (event) {
      _this.props.onInput(event);
      var clearIconVisible = event.target.value.length > 0;
      _this.setState({ clearIconVisible: clearIconVisible });
    };

    _this.handleClearIconClick = function (event) {
      _this.setState({ clearIconVisible: false });
      _this._setValue("");
      _this.props.onInput(event);
    };

    var controlled = props.value !== undefined;

    _this.state = {
      value: _this.getDefaultValue(),
      controlled: controlled
    };
    return _this;
  }

  _createClass(Search, [{
    key: "getDefaultValue",
    value: function getDefaultValue() {
      var _props = this.props,
          defaultValue = _props.defaultValue,
          value = _props.value;


      if (value !== undefined) {
        return value;
      } else if (defaultValue !== undefined) {
        return defaultValue;
      }
      return "";
    }
  }, {
    key: "getRenderedValue",
    value: function getRenderedValue() {
      var value = this.props.value;


      if (value !== undefined) {
        return value;
      }
      return this.state.value;
    }
  }, {
    key: "_setValue",
    value: function _setValue(value) {
      if (this.state.controlled) {
        this.setState({ value: this.state.value });
      } else {
        this.setState({ value: value });
      }
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(SearchAdapter, _extends({}, this.props, {
        value: this.getRenderedValue(),
        onInput: this.onInput,
        clearIconVisible: this.state.clearIconVisible,
        onClearIconClick: this.handleClearIconClick
      }));
    }
  }]);

  return Search;
}(Component);

Search.propTypes = {
  value: PropTypes.string,
  defaultValue: PropTypes.string,
  onInput: PropTypes.func
};
Search.defaultProps = {
  onInput: function onInput() {},
  value: undefined,
  defaultValue: undefined
};
export default Search;
Search.__docgenInfo = {
  "description": "",
  "displayName": "Search",
  "props": {
    "value": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "defaultValue": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onInput": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    }
  }
};