var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import SideNavAdapter from "../../../../adapters/GlobalNav/SideNav/SideNavAdapter";
import SideNavCompactAdapter from "../../../../adapters/GlobalNav/SideNav/SideNavCompactAdapter";
import SideNavFullAdapter from "../../../../adapters/GlobalNav/SideNav/SideNavFullAdapter";
import SideNavSkeletonAdapter from "../../../../adapters/GlobalNav/SideNav/SideNavSkeletonAdapter";
import Submodule from "./Submodule";
import Group from "../../../../adapters/GlobalNav/SideNav/GroupAdapter";
import Module from "./Module";
import ModuleCollapse from "./ModuleCollapse";
import Link from "../../../../adapters/GlobalNav/SideNav/LinkAdapter";
import Search from "./Search";
import WithState from "./WithState";

var SideNav = function (_Component) {
  _inherits(SideNav, _Component);

  function SideNav() {
    _classCallCheck(this, SideNav);

    return _possibleConstructorReturn(this, (SideNav.__proto__ || Object.getPrototypeOf(SideNav)).apply(this, arguments));
  }

  _createClass(SideNav, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      if (this.props.loading) {
        return React.createElement(
          SideNavAdapter,
          { higTheme: this.props.higTheme },
          React.createElement(SideNavSkeletonAdapter, { higTheme: this.props.higTheme })
        );
      }

      var mouseEventProps = {
        onMouseEnter: this.props.onMouseEnter,
        onMouseLeave: this.props.onMouseLeave
      };

      var sideNavProps = {
        copyright: this.props.copyright,
        headerLabel: this.props.headerLabel,
        headerLink: this.props.headerLink,
        onVariantToggleClick: this.props.onVariantToggleClick,
        onHeaderClick: this.props.onHeaderClick,
        onModuleClick: this.props.onModuleClick,
        onSubmoduleClick: this.props.onSubmoduleClick,
        onSuperHeaderClick: this.props.onSuperHeaderClick,
        showVariantToggleButton: this.props.showVariantToggleButton,
        superHeaderLabel: this.props.superHeaderLabel,
        superHeaderLink: this.props.superHeaderLink,
        higTheme: this.props.higTheme
      };

      var SideNavVariant = this.props.variant === "compact" ? SideNavCompactAdapter : SideNavFullAdapter;

      return React.createElement(
        SideNavAdapter,
        _extends({ higTheme: this.props.higTheme }, mouseEventProps),
        React.createElement(
          SideNavVariant,
          sideNavProps,
          this.props.groups.map(function (group) {
            return React.createElement(
              Group,
              { key: group.modules[0].id },
              group.modules.map(function (module) {
                var showSubmodules = _this2.props.disableCollapse || !module.minimized;
                var hideCollapse = _this2.props.disableCollapse || module.submodules.length === 0;
                return React.createElement(
                  Module,
                  _extends({
                    onClick: _this2.props.onModuleClick,
                    key: module.id
                  }, module),
                  React.createElement(ModuleCollapse, {
                    id: module.id,
                    minimized: module.minimized,
                    onClick: _this2.props.toggleModuleMinimized,
                    hidden: hideCollapse
                  }),
                  showSubmodules ? module.submodules.map(function (submodule) {
                    return React.createElement(Submodule, _extends({
                      onClick: _this2.props.onSubmoduleClick,
                      key: submodule.id
                    }, submodule));
                  }) : null
                );
              })
            );
          }),
          this.props.slot ? this.props.slot : null,
          this.props.links.map(function (link) {
            return React.createElement(Link, _extends({}, link, { key: link.title }));
          }),
          this.props.searchable ? React.createElement(Search, { onInput: this.props.setQuery, value: this.props.query }) : null
        )
      );
    }
  }]);

  return SideNav;
}(Component);

SideNav.propTypes = {
  copyright: PropTypes.string,
  groups: PropTypes.arrayOf(PropTypes.shape({
    modules: PropTypes.arrayOf(PropTypes.shape({
      id: PropTypes.string.isRequired,
      minimized: PropTypes.bool,
      submodules: PropTypes.arrayOf(PropTypes.shape({
        id: PropTypes.string.isRequired
      }))
    }))
  })),
  headerLabel: PropTypes.string,
  headerLink: PropTypes.string,
  links: PropTypes.arrayOf(PropTypes.object),
  onHeaderClick: PropTypes.func,
  onSuperHeaderClick: PropTypes.func,
  query: PropTypes.string,
  onModuleClick: PropTypes.func,
  onSubmoduleClick: PropTypes.func,
  onMouseEnter: PropTypes.func,
  onMouseLeave: PropTypes.func,
  searchable: PropTypes.bool,
  slot: PropTypes.node,
  superHeaderLabel: PropTypes.string,
  superHeaderLink: PropTypes.string,
  variant: PropTypes.oneOf(["full", "compact"])
};
SideNav.defaultProps = {
  copyright: null,
  groups: [],
  headerLabel: null,
  headerLink: null,
  links: [],
  onModuleClick: null,
  onSubmoduleClick: null,
  onHeaderClick: null,
  onSuperHeaderClick: null,
  onMouseEnter: function onMouseEnter() {},
  onMouseLeave: function onMouseLeave() {},
  query: "",
  superHeaderLabel: null,
  superHeaderLink: null,
  loading: false,
  variant: "full"
};


export default WithState(SideNav);
SideNav.__docgenInfo = {
  "description": "",
  "displayName": "SideNav",
  "props": {
    "copyright": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "null",
        "computed": false
      }
    },
    "groups": {
      "type": {
        "name": "arrayOf",
        "value": {
          "name": "shape",
          "value": {
            "modules": {
              "name": "arrayOf",
              "value": {
                "name": "shape",
                "value": {
                  "id": {
                    "name": "string",
                    "required": true
                  },
                  "minimized": {
                    "name": "bool",
                    "required": false
                  },
                  "submodules": {
                    "name": "arrayOf",
                    "value": {
                      "name": "shape",
                      "value": {
                        "id": {
                          "name": "string",
                          "required": true
                        }
                      }
                    },
                    "required": false
                  }
                }
              },
              "required": false
            }
          }
        }
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "[]",
        "computed": false
      }
    },
    "headerLabel": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "null",
        "computed": false
      }
    },
    "headerLink": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "null",
        "computed": false
      }
    },
    "links": {
      "type": {
        "name": "arrayOf",
        "value": {
          "name": "object"
        }
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "[]",
        "computed": false
      }
    },
    "onHeaderClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "null",
        "computed": false
      }
    },
    "onSuperHeaderClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "null",
        "computed": false
      }
    },
    "query": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "\"\"",
        "computed": false
      }
    },
    "onModuleClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "null",
        "computed": false
      }
    },
    "onSubmoduleClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "null",
        "computed": false
      }
    },
    "onMouseEnter": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onMouseLeave": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "searchable": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": ""
    },
    "slot": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": ""
    },
    "superHeaderLabel": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "null",
        "computed": false
      }
    },
    "superHeaderLink": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "null",
        "computed": false
      }
    },
    "variant": {
      "type": {
        "name": "enum",
        "value": [{
          "value": "\"full\"",
          "computed": false
        }, {
          "value": "\"compact\"",
          "computed": false
        }]
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "\"full\"",
        "computed": false
      }
    },
    "loading": {
      "defaultValue": {
        "value": "false",
        "computed": false
      },
      "required": false
    }
  }
};