var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import * as PropTypes from "prop-types";

import { filter, group, mergeState, getModuleState } from "./model";

export default function WithState(WrappedComponent) {
  var SideNavWithState = function (_Component) {
    _inherits(SideNavWithState, _Component);

    function SideNavWithState(props) {
      _classCallCheck(this, SideNavWithState);

      var _this = _possibleConstructorReturn(this, (SideNavWithState.__proto__ || Object.getPrototypeOf(SideNavWithState)).call(this, props));

      _this.setQuery = function (event) {
        _this.setState({ query: event.target.value || "" });
      };

      _this.setActiveModuleId = function (id) {
        _this.setState({ activeModuleId: id });

        if (_this.props.onModuleChange) {
          _this.props.onModuleChange(id);
        }
      };

      _this._submodulesByModuleId = function () {
        return _this.props.submodules.reduce(function (result, submodule) {
          var key = submodule.moduleId;

          if (result[key]) {
            result[key].push(submodule);
          } else {
            result[key] = [submodule]; // eslint-disable-line no-param-reassign
          }
          return result;
        }, {});
      };

      _this.initialModuleStates = function () {
        var moduleStates = {};
        var groupedSubmodules = _this._submodulesByModuleId();
        Object.keys(groupedSubmodules).forEach(function (moduleId) {
          var isLargeModule = groupedSubmodules[moduleId].length > 5;
          var isInactiveModule = moduleId !== _this.props.activeModuleId;

          var moduleProps = _this.props.modules.find(function (module) {
            return module.id === moduleId;
          });

          var initialModuleState = moduleProps && typeof moduleProps.minimized !== "undefined" ? moduleProps.minimized : isLargeModule && isInactiveModule;

          moduleStates[moduleId] = {
            minimized: initialModuleState
          };
        });

        return moduleStates;
      };

      _this.toggleModuleMinimized = function (id) {
        var moduleState = getModuleState(_this.state.moduleStates, id);

        _this.setState({
          moduleStates: _extends({}, _this.state.moduleStates, _defineProperty({}, id, _extends({}, moduleState, {
            minimized: !moduleState.minimized
          })))
        });
      };

      _this.handleModuleClick = function (id) {
        _this.toggleModuleMinimized(id);
        _this.setActiveModuleId(id);

        if (_this.props.onModuleClick) {
          _this.props.onModuleClick(id);
        }
      };

      _this.handleSubmoduleClick = function (id) {
        _this.setActiveModuleId(id);
        if (_this.props.onSubmoduleClick) {
          _this.props.onSubmoduleClick(id);
        }
      };

      _this.state = {
        query: "",
        activeModuleId: _this.props.activeModuleId,
        moduleStates: _this.initialModuleStates()
      };
      return _this;
    }

    _createClass(SideNavWithState, [{
      key: "renderedQuery",
      value: function renderedQuery() {
        return this.props.query ? this.props.query : this.state.query;
      }
    }, {
      key: "render",
      value: function render() {
        var query = this.renderedQuery();

        var _props = this.props,
            modules = _props.modules,
            submodules = _props.submodules,
            otherProps = _objectWithoutProperties(_props, ["modules", "submodules"]);

        var filteredProps = filter(this.props, query);
        var filteredPropsWithState = mergeState(filteredProps, this.state);
        var groupedProps = group(filteredPropsWithState);

        return React.createElement(WrappedComponent, _extends({}, otherProps, {
          groups: groupedProps,
          query: query,
          setQuery: this.setQuery,
          setActiveModuleId: this.setActiveModuleId,
          toggleModuleMinimized: this.toggleModuleMinimized,
          onModuleClick: this.handleModuleClick,
          onSubmoduleClick: this.handleSubmoduleClick,
          disableCollapse: modules.length <= 5 || query.length > 0,
          searchable: this.props.searchable
        }));
      }
    }]);

    return SideNavWithState;
  }(Component);

  SideNavWithState.propTypes = {
    links: PropTypes.arrayOf(PropTypes.object),
    modules: PropTypes.arrayOf(PropTypes.shape({
      id: PropTypes.string.isRequired,
      title: PropTypes.string.isRequired,
      minimized: PropTypes.bool
    })),
    onModuleChange: PropTypes.func.isRequired,
    submodules: PropTypes.arrayOf(PropTypes.shape({
      id: PropTypes.string.isRequired,
      title: PropTypes.string.isRequired
    })),
    activeModuleId: PropTypes.string
  };
  SideNavWithState.defaultProps = {
    activeModuleId: null,
    query: "",
    modules: [],
    submodules: [],
    links: []
  };


  SideNavWithState.__docgenInfo = {
    props: {
      activeModuleId: {
        description: "id of the active module or submodule"
      },
      links: {
        description: "An array of props for building links on the bottom of the side nav"
      },
      modules: {
        description: "An array of props for building modules"
      },
      onModuleChange: {
        description: "A funciton that will be called when the user activates a module or submodule"
      },
      onModuleClick: {
        description: "A funciton that will be called when the user clicks on a module"
      },
      onSubmoduleClick: {
        description: "A funciton that will be called when the user clicks on a submodule"
      },
      submodules: {
        description: "An array of props for building submodules"
      }
    }
  };

  return SideNavWithState;
}