var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* eslint-disable react/no-multi-comp */
/* eslint-disable react/jsx-no-bind */

import React from "react";

import TabsAdapter from "../../../../adapters/GlobalNav/SubNav/TabsAdapter";
import TabAdapter from "../../../../adapters/GlobalNav/SubNav/TabAdapter";

var Tab = function (_React$Component) {
  _inherits(Tab, _React$Component);

  function Tab() {
    _classCallCheck(this, Tab);

    return _possibleConstructorReturn(this, (Tab.__proto__ || Object.getPrototypeOf(Tab)).apply(this, arguments));
  }

  _createClass(Tab, [{
    key: "render",

    // This is never actually rendered
    value: function render() {
      return React.createElement("div", null);
    }
  }]);

  return Tab;
}(React.Component);

function isTab(child) {
  return child != null && child.type === Tab;
}

var Tabs = function (_React$Component2) {
  _inherits(Tabs, _React$Component2);

  function Tabs(props) {
    _classCallCheck(this, Tabs);

    var _this2 = _possibleConstructorReturn(this, (Tabs.__proto__ || Object.getPrototypeOf(Tabs)).call(this, props));

    var selectedTabId = _this2.defaultSelectedTabId();
    _this2.state = { selectedTabId: selectedTabId };
    return _this2;
  }

  _createClass(Tabs, [{
    key: "getTabChildren",
    value: function getTabChildren() {
      return React.Children.toArray(this.props.children).filter(isTab);
    }
  }, {
    key: "defaultSelectedTabId",
    value: function defaultSelectedTabId() {
      var _props = this.props,
          defaultSelectedTabId = _props.defaultSelectedTabId,
          selectedTabId = _props.selectedTabId;


      if (selectedTabId !== undefined) {
        return selectedTabId;
      } else if (defaultSelectedTabId !== undefined) {
        return defaultSelectedTabId;
      }
      // select first tab in absence of user input
      var tabs = this.getTabChildren();
      return tabs.length === 0 ? undefined : tabs[0].props.id;
    }
  }, {
    key: "handleTabClick",
    value: function handleTabClick(newTabId) {
      if (this.props.onChange) {
        this.props.onChange(newTabId, this.renderedSelectedTabId());
      }

      this.setState({ selectedTabId: newTabId });
    }
  }, {
    key: "renderTab",
    value: function renderTab(tab) {
      var id = tab.props.id;


      return React.createElement(TabAdapter, _extends({}, tab.props, {
        active: id === this.renderedSelectedTabId(),
        onClick: this.handleTabClick.bind(this, id)
      }));
    }
  }, {
    key: "renderedSelectedTabId",
    value: function renderedSelectedTabId() {
      return this.props.selectedTabId ? this.props.selectedTabId : this.state.selectedTabId;
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var tabs = React.Children.map(this.props.children, function (child) {
        return isTab(child) ? _this3.renderTab(child) : null;
      });
      return React.createElement(
        TabsAdapter,
        null,
        tabs
      );
    }
  }]);

  return Tabs;
}(React.Component);

Tabs.Tab = Tab;

export default Tabs;
Tabs.__docgenInfo = {
  "description": "",
  "displayName": "Tabs"
};