var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";

import NotificationAdapter from "../../../../adapters/GlobalNav/TopNav/NotificationAdapter";

var Notification = function (_Component) {
  _inherits(Notification, _Component);

  function Notification(props) {
    _classCallCheck(this, Notification);

    var _this = _possibleConstructorReturn(this, (Notification.__proto__ || Object.getPrototypeOf(Notification)).call(this, props));

    _this.onLinkClick = function () {
      _this.props.onLinkClick(_this.props.id);
    };

    _this.state = {
      unread: _this.props.unread
    };
    _this.initialProps = props;
    return _this;
  }

  _createClass(Notification, [{
    key: "render",
    value: function render() {
      return React.createElement(
        NotificationAdapter,
        _extends({}, this.props, {
          onLinkClick: this.onLinkClick,
          id: this.props.id,
          unread: this.props.unread
        }),
        this.props.children
      );
    }
  }]);

  return Notification;
}(Component);

export default Notification;


export function notificationElementPropType(props, propName) {
  var value = props[propName];
  if (value && value.type && value.type === Notification.name) {
    return new Error("Expected an element of type Notification.");
  }
  return null;
}

Notification.defaultProps = {
  onLinkClick: function onLinkClick() {}
};

Notification.propTypes = {
  /**
   * {Boolean} to show specify whether notification is read
   */
  unread: PropTypes.bool,
  /**
   * Content for notification
   */
  children: PropTypes.node,
  /**
   * Timestamp for notification (ISO date string or date instance)
   */
  timestamp: PropTypes.oneOfType([PropTypes.string, PropTypes.instanceOf(Date)]),
  /**
   * A callback called when user clicks on a link in the notification
   */
  onLinkClick: PropTypes.func,
  /**
   * A callback called when user dismisses a featured notification
   */
  onDismiss: PropTypes.func,
  /**
   * Unique Id for the notification
   */
  id: PropTypes.oneOfType([PropTypes.number, PropTypes.string]).isRequired,
  /**
   * {Boolean} specifies a featured notification
   */
  featured: PropTypes.bool
};
Notification.__docgenInfo = {
  "description": "",
  "displayName": "Notification",
  "props": {
    "unread": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "{Boolean} to show specify whether notification is read"
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Content for notification"
    },
    "timestamp": {
      "type": {
        "name": "union",
        "value": [{
          "name": "string"
        }, {
          "name": "instanceOf",
          "value": "Date"
        }]
      },
      "required": false,
      "description": "Timestamp for notification (ISO date string or date instance)"
    },
    "onLinkClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "A callback called when user clicks on a link in the notification",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onDismiss": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "A callback called when user dismisses a featured notification"
    },
    "id": {
      "type": {
        "name": "union",
        "value": [{
          "name": "number"
        }, {
          "name": "string"
        }]
      },
      "required": true,
      "description": "Unique Id for the notification"
    },
    "featured": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "{Boolean} specifies a featured notification"
    }
  }
};