var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";

import NotificationsAdapter from "../../../../adapters/GlobalNav/TopNav/NotificationsAdapter";
import { notificationElementPropType } from "./Notification";

var Notifications = function (_Component) {
  _inherits(Notifications, _Component);

  function Notifications(props) {
    _classCallCheck(this, Notifications);

    var _this = _possibleConstructorReturn(this, (Notifications.__proto__ || Object.getPrototypeOf(Notifications)).call(this, props));

    _this.onScroll = function (event) {
      return _this.props.onScroll && _this.props.onScroll(event);
    };

    _this.onClick = function (event) {
      if (_this.props.onClick) {
        _this.props.onClick({
          event: event
        });
      }

      _this.setState({
        open: true
      });
    };

    _this.onClickOutside = function (event) {
      _this.setState({
        open: false,
        seenNotificationIds: _this.notificationIds(),
        featuredNotificationSeen: true
      });

      if (_this.props.onClickOutside) {
        _this.props.onClickOutside(event);
      }
    };

    _this.unseenCount = function () {
      var count = _this.props.featuredNotification && !_this.state.featuredNotificationSeen ? 1 : 0;

      if (!_this.props.children) {
        return count;
      }

      count += _this.notificationIds().filter(function (id) {
        return _this.state.seenNotificationIds.indexOf(id) === -1;
      }).length;

      return Math.min(count, 99);
    };

    _this.state = {
      open: _this.props.open,
      seenNotificationIds: _this.readIds()
    };
    return _this;
  }

  _createClass(Notifications, [{
    key: "readIds",
    value: function readIds() {
      return React.Children.toArray(this.props.children).filter(function (c) {
        return !c.props.unread;
      }).map(function (c) {
        return c.props.id;
      });
    }
  }, {
    key: "notificationIds",
    value: function notificationIds() {
      return React.Children.map(this.props.children, function (child) {
        return child.props.id;
      });
    }
  }, {
    key: "render",
    value: function render() {
      var unseenCount = this.unseenCount();
      return React.createElement(
        NotificationsAdapter,
        _extends({}, this.props, {
          onClick: this.onClick,
          onClickOutside: this.onClickOutside,
          onScroll: this.onScroll,
          open: this.state.open,
          unseenCount: unseenCount,
          showNotificationsCount: unseenCount > 0
        }),
        this.props.featuredNotification && React.cloneElement(this.props.featuredNotification, {
          featured: true,
          unread: false // Hide unread indicator on featured notifications
        }),
        this.props.children
      );
    }
  }]);

  return Notifications;
}(Component);

export default Notifications;


Notifications.propTypes = {
  /**
   * Opens the notifications flyout
   */
  open: PropTypes.bool,
  /**
   * Show the loading indicator
   */
  loading: PropTypes.bool,
  /**
   * Calls the provided callback when user clicks on the notifications icon in the top nav
   */
  onClick: PropTypes.func,
  /**
   * Calls the provided callback when user clicks outside the dropdown
   */
  onClickOutside: PropTypes.func,
  /**
   * Calls the provided callback when the notifications content is scrolled
   */
  onScroll: PropTypes.func,
  /**
   * The title text that renders above the notifications list
   */
  title: PropTypes.string,
  /**
   * A Notification component, to be styled as a featured notification
   */
  featuredNotification: notificationElementPropType
};

Notifications.defaultProps = {
  onClick: function onClick() {},
  onClickOutside: function onClickOutside() {},
  onScroll: function onScroll() {},
  title: "Notifications",
  children: []
};
Notifications.__docgenInfo = {
  "description": "",
  "displayName": "Notifications",
  "props": {
    "open": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Opens the notifications flyout"
    },
    "loading": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Show the loading indicator"
    },
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Calls the provided callback when user clicks on the notifications icon in the top nav",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onClickOutside": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Calls the provided callback when user clicks outside the dropdown",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onScroll": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Calls the provided callback when the notifications content is scrolled",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "title": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "The title text that renders above the notifications list",
      "defaultValue": {
        "value": "\"Notifications\"",
        "computed": false
      }
    },
    "featuredNotification": {
      "type": {
        "name": "custom",
        "raw": "notificationElementPropType"
      },
      "required": false,
      "description": "A Notification component, to be styled as a featured notification"
    },
    "children": {
      "defaultValue": {
        "value": "[]",
        "computed": false
      },
      "required": false
    }
  }
};