var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * ProjectAccountSwitcher
 *
 *
 *
 */

import React, { Component } from "react";
import PropTypes from "prop-types";

import ProjectAccountSwitcherAdapter from "../../../../adapters/GlobalNav/TopNav/ProjectAccountSwitcherAdapter"; // eslint-disable-line max-len
import Project from "./Project";
import Account from "./Account";

var ProjectAccountSwitcher = function (_Component) {
  _inherits(ProjectAccountSwitcher, _Component);

  function ProjectAccountSwitcher(props) {
    _classCallCheck(this, ProjectAccountSwitcher);

    var _this = _possibleConstructorReturn(this, (ProjectAccountSwitcher.__proto__ || Object.getPrototypeOf(ProjectAccountSwitcher)).call(this, props));

    _this.toggleOpen = function () {
      _this.setState({ open: !_this.state.open });
    };

    _this.handleProjectClick = function (id) {
      _this.setState({
        activeProjectId: id,
        open: false
      });
      if (_this.props.onProjectClick) {
        _this.props.onProjectClick(id);
      }
    };

    _this.handleAccountClick = function (id) {
      _this.setState({
        activeAccountId: id,
        open: false
      });
      if (_this.props.onAccountClick) {
        _this.props.onAccountClick(id);
      }
    };

    _this.state = {};
    return _this;
  }

  _createClass(ProjectAccountSwitcher, [{
    key: "activeProps",
    value: function activeProps() {
      var _this2 = this;

      var activeAccount = this.props.accounts.find(function (a) {
        return a.id === _this2.renderedActiveAccountId();
      });
      var activeProject = this.props.projects.find(function (a) {
        return a.id === _this2.renderedActiveProjectId();
      });

      if (activeAccount && activeProject) {
        var activeLabel = [activeAccount.label, activeProject.label].join(" / ");
        return {
          activeImage: activeProject.image,
          activeLabel: activeLabel,
          activeType: "project"
        };
      } else if (activeProject) {
        return {
          activeImage: activeProject.image,
          activeLabel: activeProject.label,
          activeType: "project"
        };
      } else if (activeAccount) {
        return {
          activeImage: activeAccount.image,
          activeLabel: activeAccount.label,
          activeType: "account"
        };
      }

      return {};
    }
  }, {
    key: "flyoutProps",
    value: function flyoutProps() {
      if (this.props.projects.length > 1 || this.props.accounts.length > 1) {
        return {
          showCaret: true,
          onClick: this.toggleOpen,
          onClickOutside: this.toggleOpen
        };
      }

      return {};
    }
  }, {
    key: "renderedActiveProjectId",
    value: function renderedActiveProjectId() {
      if (this.props.activeProjectId !== undefined) {
        return this.props.activeProjectId;
      } else if (this.state.activeProjectId !== undefined) {
        return this.state.activeProjectId;
      }
      return this.props.projects[0].id;
    }
  }, {
    key: "renderedActiveAccountId",
    value: function renderedActiveAccountId() {
      if (this.props.activeAccountId !== undefined) {
        return this.props.activeAccountId;
      } else if (this.state.activeAccountId !== undefined) {
        return this.state.activeAccountId;
      }
      return this.props.accounts[0].id;
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var projects = this.props.projects.map(function (project) {
        return _extends({}, project, {
          active: project.id === _this3.renderedActiveProjectId()
        });
      });
      var accounts = this.props.accounts.map(function (account) {
        return _extends({}, account, {
          active: account.id === _this3.renderedActiveAccountId()
        });
      });

      return React.createElement(
        ProjectAccountSwitcherAdapter,
        _extends({
          open: this.state.open,
          projectTitle: this.props.projectTitle,
          accountTitle: this.props.accountTitle
        }, this.flyoutProps(), this.activeProps()),
        accounts.map(function (a, i) {
          if (i === 0) {
            return React.createElement(Account, _extends({ onClick: _this3.handleAccountClick, key: a.id }, a));
          }
          return React.createElement(Account, _extends({ onClick: _this3.handleAccountClick, key: a.id }, a));
        }),
        projects.map(function (p, i) {
          if (i === 0) {
            return React.createElement(Project, _extends({ onClick: _this3.handleProjectClick, key: p.id }, p));
          }
          return React.createElement(Project, _extends({ onClick: _this3.handleProjectClick, key: p.id }, p));
        })
      );
    }
  }]);

  return ProjectAccountSwitcher;
}(Component);

ProjectAccountSwitcher.propTypes = {
  accounts: PropTypes.arrayOf(PropTypes.shape({
    id: PropTypes.string,
    image: PropTypes.string,
    label: PropTypes.string
  })),
  projects: PropTypes.arrayOf(PropTypes.shape({
    id: PropTypes.string,
    image: PropTypes.string,
    label: PropTypes.string
  })),
  activeProjectId: PropTypes.string,
  activeAccountId: PropTypes.string,
  projectTitle: PropTypes.string,
  accountTitle: PropTypes.string,
  onProjectClick: PropTypes.func,
  onAccountClick: PropTypes.func
};
ProjectAccountSwitcher.defaultProps = {
  accounts: [],
  projects: []
};


export default ProjectAccountSwitcher;
ProjectAccountSwitcher.__docgenInfo = {
  "description": "",
  "displayName": "ProjectAccountSwitcher",
  "props": {
    "accounts": {
      "type": {
        "name": "arrayOf",
        "value": {
          "name": "shape",
          "value": {
            "id": {
              "name": "string",
              "required": false
            },
            "image": {
              "name": "string",
              "required": false
            },
            "label": {
              "name": "string",
              "required": false
            }
          }
        }
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "[]",
        "computed": false
      }
    },
    "projects": {
      "type": {
        "name": "arrayOf",
        "value": {
          "name": "shape",
          "value": {
            "id": {
              "name": "string",
              "required": false
            },
            "image": {
              "name": "string",
              "required": false
            },
            "label": {
              "name": "string",
              "required": false
            }
          }
        }
      },
      "required": false,
      "description": "",
      "defaultValue": {
        "value": "[]",
        "computed": false
      }
    },
    "activeProjectId": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": ""
    },
    "activeAccountId": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": ""
    },
    "projectTitle": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": ""
    },
    "accountTitle": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": ""
    },
    "onProjectClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": ""
    },
    "onAccountClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": ""
    }
  }
};