var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import SearchAdapter from "../../../../adapters/GlobalNav/TopNav/SearchAdapter";
import Option from "../../FormElements/Option";

var Search = function (_Component) {
  _inherits(Search, _Component);

  function Search(props) {
    _classCallCheck(this, Search);

    var _this = _possibleConstructorReturn(this, (Search.__proto__ || Object.getPrototypeOf(Search)).call(this, props));

    _this.onInput = function (event) {
      _this.props.onInput({ value: event.target.value });
      var clearIconVisible = event.target.value.length > 0;
      _this.setState({ showOptions: true, clearIconVisible: clearIconVisible });
    };

    _this.handleOptionSelect = function () {
      var selectedOption = _this.props.options[_this.state.focusedOptionIndex];

      _this.props.onOptionSelect(selectedOption);
      _this.hideOptions();
    };

    _this.handleOptionHover = function (focusedOptionIndex) {
      return function () {
        return _this.setState({ focusedOptionIndex: focusedOptionIndex });
      };
    };

    _this.hideOptions = function () {
      _this.setState({ showOptions: false, focusedOptionIndex: undefined });
    };

    _this.showOptions = function () {
      var value = _this.props.options !== undefined ? _this.props.options.length > 0 && _this.state.showOptions : false;
      return value;
    };

    _this.handleClearIconClick = function () {
      _this.setValue("");
      _this.props.onInput({ value: "" });
      _this.setState({ focusedOptionIndex: undefined, clearIconVisible: false });
    };

    _this.handleKeydown = function (event) {
      switch (event.keyCode) {
        case 40:
          event.preventDefault();
          _this.focusPrevious();
          break;
        case 37:
          event.preventDefault();
          _this.focusPrevious();
          break;
        case 38:
          event.preventDefault();
          _this.focusNext();
          break;
        case 39:
          event.preventDefault();
          _this.focusNext();
          break;
        case 13:
          _this.handleEnterPress(event.target.value);
          break;
        default:
          break;
      }
    };

    var controlled = props.value !== undefined;

    _this.state = {
      showOptions: false,
      value: undefined,
      controlled: controlled
    };
    return _this;
  }

  _createClass(Search, [{
    key: "setValue",
    value: function setValue(value) {
      if (this.state.controlled) {
        this.setState({ value: this.state.value });
      } else {
        this.setState({ value: value });
      }
    }
  }, {
    key: "handleEnterPress",
    value: function handleEnterPress(selectedValue) {
      if (this.state.focusedOptionIndex !== undefined) {
        this.handleOptionSelect(selectedValue);
        return;
      }

      this.props.onSubmit({ selectedValue: selectedValue });
      this.hideOptions();
    }
  }, {
    key: "focusPrevious",
    value: function focusPrevious() {
      if (this.state.focusedOptionIndex === undefined || this.state.focusedOptionIndex >= this.props.options.length - 1) {
        this.setState({ focusedOptionIndex: 0, showOptions: true });
      } else {
        var focusedOptionIndex = this.state.focusedOptionIndex + 1;
        this.setState({ focusedOptionIndex: focusedOptionIndex, showOptions: true });
      }
    }
  }, {
    key: "focusNext",
    value: function focusNext() {
      if (this.state.focusedOptionIndex === undefined || this.state.focusedOptionIndex <= 0) {
        var focusedOptionIndex = this.props.options.length - 1;
        this.setState({ focusedOptionIndex: focusedOptionIndex, showOptions: true });
      } else {
        var _focusedOptionIndex = this.state.focusedOptionIndex - 1;
        this.setState({ focusedOptionIndex: _focusedOptionIndex, showOptions: true });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        SearchAdapter,
        _extends({}, this.props, {
          value: this.props.value,
          onInput: this.onInput,
          showOptions: this.showOptions(),
          showClearIcon: this.state.clearIconVisible,
          onClearIconClick: this.handleClearIconClick,
          onClickOutside: this.hideOptions,
          onKeydown: this.handleKeydown
        }),
        this.props.options !== undefined && this.props.options.length > 0 ? this.props.options.map(function (option, index) {
          return React.createElement(Option, _extends({
            key: option.value,
            focused: index === _this2.state.focusedOptionIndex
          }, option, {
            onClick: _this2.handleOptionSelect,
            onHover: _this2.handleOptionHover(index)
          }));
        }) : null
      );
    }
  }]);

  return Search;
}(Component);

Search.defaultProps = {
  onBlur: function onBlur() {},
  onClearIconClick: function onClearIconClick() {},
  onClickOutside: function onClickOutside() {},
  onFocus: function onFocus() {},
  onInput: function onInput() {},
  onKeydown: function onKeydown() {},
  onOptionSelect: function onOptionSelect() {},
  onSubmit: function onSubmit() {},
  showClearIcon: undefined,
  showOptions: undefined,
  value: undefined
};
export default Search;


Search.propTypes = {
  /**
   * Autocomplete options to present when begins typing their query
   */
  options: PropTypes.arrayOf(PropTypes.shape({
    label: PropTypes.node,
    value: PropTypes.string
  })),
  /**
   * Calls the provided callback when user enters text in Search input
   */
  onInput: PropTypes.func,
  /**
   * Value of search input
   */
  value: PropTypes.string,
  /**
   * Shows filtered options
   */
  showOptions: PropTypes.bool,
  /**
   * Calls the callback on Blur
   */
  onBlur: PropTypes.func,
  /**
   * Calls the callback on Focus
   */
  onFocus: PropTypes.func,
  /**
   * Show the clear input icon
   */
  showClearIcon: PropTypes.bool,
  /**
   * Calls the provided callback when the clear icon is clicked
   */
  onClearIconClick: PropTypes.func,
  /**
   * Calls the provided callback when user clicks outside of the auto-complete menu
   */
  onClickOutside: PropTypes.func,
  /**
   * Calls the provided callback when user presses a key when the Search has focus
   */
  onKeydown: PropTypes.func,
  /**
   * Calls the provided callback when user presses Enter key while the Search has focus
   */
  onSubmit: PropTypes.func,
  /**
   * Calls the provided callback when user selects an auto-complete option
   */
  onOptionSelect: PropTypes.func
};
Search.__docgenInfo = {
  "description": "",
  "displayName": "Search",
  "props": {
    "options": {
      "type": {
        "name": "arrayOf",
        "value": {
          "name": "shape",
          "value": {
            "label": {
              "name": "node",
              "required": false
            },
            "value": {
              "name": "string",
              "required": false
            }
          }
        }
      },
      "required": false,
      "description": "Autocomplete options to present when begins typing their query"
    },
    "onInput": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Calls the provided callback when user enters text in Search input",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "value": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Value of search input",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "showOptions": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Shows filtered options",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onBlur": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Calls the callback on Blur",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onFocus": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Calls the callback on Focus",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "showClearIcon": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Show the clear input icon",
      "defaultValue": {
        "value": "undefined",
        "computed": true
      }
    },
    "onClearIconClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Calls the provided callback when the clear icon is clicked",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onClickOutside": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Calls the provided callback when user clicks outside of the auto-complete menu",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onKeydown": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Calls the provided callback when user presses a key when the Search has focus",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onSubmit": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Calls the provided callback when user presses Enter key while the Search has focus",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "onOptionSelect": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Calls the provided callback when user selects an auto-complete option",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    }
  }
};