var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from "react";
import PropTypes from "prop-types";
import { Modal as VanillaModal } from "hig-vanilla";
import ModalAdapter from "../../adapters/ModalAdapter";
import Button from "../../adapters/ButtonAdapter";

var Modal = function (_React$Component) {
  _inherits(Modal, _React$Component);

  function Modal(props) {
    _classCallCheck(this, Modal);

    var _this = _possibleConstructorReturn(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).call(this, props));

    _this.state = { open: false };
    return _this;
  }

  _createClass(Modal, [{
    key: "render",
    value: function render() {
      return React.createElement(
        ModalAdapter,
        {
          body: this.props.body,
          buttons: this.props.buttons,
          style: this.props.style,
          open: this.props.open,
          onCloseClick: this.props.onClose,
          onOverlayClick: this.props.onClose,
          title: this.props.title,
          slotEl: this.state.slotEl
        },
        this.props.children
      );
    }
  }]);

  return Modal;
}(React.Component);

export default Modal;


Modal.propTypes = {
  /**
   * Text or html string content of the modal
   */
  body: PropTypes.string,
  /**
   * An array of props supported by the Button component
   */
  buttons: PropTypes.arrayOf(PropTypes.shape(Button.propTypes)),
  /**
   * Ssupports adding any dom content to the body of the modal
   */
  children: PropTypes.node,
  /**
   * Triggers when the modal closes
   */
  onClose: PropTypes.func,
  /**
   * Modal is visible when true
   */
  open: PropTypes.bool,
  /**
   * Style of the modal shell
   */
  style: PropTypes.oneOf(VanillaModal.AvailableStyles),
  /**
   * Title of the modal
   */
  title: PropTypes.string
};

Modal.defaultProps = {
  onClose: function onClose() {}
};
Modal.__docgenInfo = {
  "description": "",
  "displayName": "Modal",
  "props": {
    "body": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Text or html string content of the modal"
    },
    "buttons": {
      "type": {
        "name": "arrayOf",
        "value": {
          "name": "shape",
          "value": "Button.propTypes",
          "computed": true
        }
      },
      "required": false,
      "description": "An array of props supported by the Button component"
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Ssupports adding any dom content to the body of the modal"
    },
    "onClose": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Triggers when the modal closes",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "open": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Modal is visible when true"
    },
    "style": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaModal.AvailableStyles"
      },
      "required": false,
      "description": "Style of the modal shell"
    },
    "title": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Title of the modal"
    }
  }
};