var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import Transition from "react-transition-group/Transition";
import PropTypes from "prop-types";
import cx from "classnames";
import IconButton from "@hig/icon-button";
import Timestamp from "@hig/timestamp";
import RichText from "../RichText";
import "./notification.scss";

var COMPONENT_CLASS = "hig__notification";
var FEATURED_COMPONENT_CLASS = "hig__notification--featured";
var CONTENT_CLASS = "hig__notification__content";

var Notification = function (_Component) {
  _inherits(Notification, _Component);

  function Notification(props) {
    _classCallCheck(this, Notification);

    var _this = _possibleConstructorReturn(this, (Notification.__proto__ || Object.getPrototypeOf(Notification)).call(this, props));

    _this.onClickCapture = function (event) {
      if (event.target.tagName === "A" && _this.props.onLinkClick) {
        _this.props.onLinkClick(_this.props.id);
      }
    };

    _this.dismissFeaturedNotification = function () {
      _this.props.onDismiss();
      _this.setState({ in: false });
    };

    _this.state = {
      in: true
    };
    return _this;
  }

  _createClass(Notification, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var notificationClasses = cx("" + COMPONENT_CLASS, _defineProperty({}, "hig__notification--" + this.props.type, this.props.type), _defineProperty({}, "hig__notification--unread", this.props.unread));

      var notification = this.props.featured ? React.createElement(
        Transition,
        { "in": this.state.in, timeout: 300 },
        function (state) {
          return React.createElement(
            "div",
            {
              className: notificationClasses + " hig__notification--" + state + " " + FEATURED_COMPONENT_CLASS,
              onClickCapture: _this2.onClickCapture
            },
            React.createElement(
              "div",
              { className: "" + CONTENT_CLASS },
              React.createElement(
                RichText,
                { size: "small" },
                _this2.props.children
              ),
              React.createElement(IconButton, {
                onClick: _this2.dismissFeaturedNotification,
                icon: "close-notification",
                title: "Dismiss featured notification",
                type: "transparent"
              })
            ),
            _this2.props.timestamp ? React.createElement(Timestamp, { timestamp: _this2.props.timestamp }) : null
          );
        }
      ) : React.createElement(
        "div",
        { className: notificationClasses, onClickCapture: this.onClickCapture },
        React.createElement(
          "div",
          { className: "" + CONTENT_CLASS },
          React.createElement(
            RichText,
            { size: "small" },
            this.props.children
          )
        ),
        this.props.timestamp ? React.createElement(Timestamp, { timestamp: this.props.timestamp }) : null
      );

      return notification;
    }
  }]);

  return Notification;
}(Component);

export default Notification;


Notification.propTypes = {
  /**
   * A callback called when user clicks on a link in the notification
   */
  onLinkClick: PropTypes.func,
  /**
   * A callback called when user dismisses a featured notification
   */
  onDismiss: PropTypes.func,
  /**
   * {Boolean} to show specify whether notificaiton is read
   */
  unread: PropTypes.bool,
  /**
   * Indicates whether this is a featured notification
   */
  featured: PropTypes.bool,
  /**
   * specifies type of notification
   */
  type: PropTypes.string,
  /**
   * id for notification
   */
  id: PropTypes.number,
  /**
   * Content for notification
   */
  children: PropTypes.node,
  /**
   * Timestamp for notification
   */
  timestamp: PropTypes.string // ISO date string
};
Notification.__docgenInfo = {
  "description": "",
  "displayName": "Notification",
  "props": {
    "onLinkClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "A callback called when user clicks on a link in the notification"
    },
    "onDismiss": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "A callback called when user dismisses a featured notification"
    },
    "unread": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "{Boolean} to show specify whether notificaiton is read"
    },
    "featured": {
      "type": {
        "name": "bool"
      },
      "required": false,
      "description": "Indicates whether this is a featured notification"
    },
    "type": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "specifies type of notification"
    },
    "id": {
      "type": {
        "name": "number"
      },
      "required": false,
      "description": "id for notification"
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Content for notification"
    },
    "timestamp": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Timestamp for notification"
    }
  }
};