var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import cx from "classnames";
import "./rich-text.scss";
import _AVAILABLE_SIZES from "./sizes";

var COMPONENT_CLASS = "hig__rich-text";

var RichText = function (_Component) {
  _inherits(RichText, _Component);

  function RichText() {
    _classCallCheck(this, RichText);

    return _possibleConstructorReturn(this, (RichText.__proto__ || Object.getPrototypeOf(RichText)).apply(this, arguments));
  }

  _createClass(RichText, [{
    key: "render",
    value: function render() {
      var richTextClasses = cx("" + COMPONENT_CLASS, _defineProperty({}, "hig__rich-text--" + this.props.size, this.props.size));
      return this.props.children ? React.createElement(
        "div",
        { className: richTextClasses },
        this.props.children
      ) : React.createElement("div", {
        className: richTextClasses,
        dangerouslySetInnerHTML: this.props.dangerouslySetInnerHTML // eslint-disable-line react/no-danger
      });
    }
  }]);

  return RichText;
}(Component);

export default RichText;


RichText.propTypes = {
  /**
   * React-generated markup to style with HIG typography rules
   */
  children: PropTypes.node,
  /**
   * HTML string to be rendered and styled with HIG typography ruless
   */
  dangerouslySetInnerHTML: PropTypes.shape({
    __html: PropTypes.string
  }),
  /**
   * String which specifies which size of RichText will be used
   */
  size: PropTypes.oneOf(_AVAILABLE_SIZES)
};
RichText.__docgenInfo = {
  "description": "",
  "displayName": "RichText",
  "props": {
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "React-generated markup to style with HIG typography rules"
    },
    "dangerouslySetInnerHTML": {
      "type": {
        "name": "shape",
        "value": {
          "__html": {
            "name": "string",
            "required": false
          }
        }
      },
      "required": false,
      "description": "HTML string to be rendered and styled with HIG typography ruless"
    },
    "size": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "_AVAILABLE_SIZES"
      },
      "required": false,
      "description": "String which specifies which size of RichText will be used"
    }
  }
};