var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* eslint-disable jsx-a11y/no-static-element-interactions
*/

import React, { Component } from "react";
import PropTypes from "prop-types";

import IconButton from "@hig/icon-button";

var COMPONENT_CLASS = "hig__shortcut";

var Shortcut = function (_Component) {
  _inherits(Shortcut, _Component);

  function Shortcut() {
    _classCallCheck(this, Shortcut);

    return _possibleConstructorReturn(this, (Shortcut.__proto__ || Object.getPrototypeOf(Shortcut)).apply(this, arguments));
  }

  _createClass(Shortcut, [{
    key: "render",
    value: function render() {
      return React.createElement(
        "div",
        { className: COMPONENT_CLASS, title: this.props.title },
        React.createElement(IconButton, {
          type: "transparent",
          title: this.props.title,
          icon: this.props.icon,
          onClick: this.props.onClick,
          link: this.props.link
        })
      );
    }
  }]);

  return Shortcut;
}(Component);

export default Shortcut;


Shortcut.propTypes = {
  /**
   * Link that the shortcut will navigate to
   */
  link: PropTypes.string,
  /**
   * Title attribute for shortcut
   */
  title: PropTypes.string,
  /**
   * Callback function for when shortcut is clicked
   */
  onClick: PropTypes.func,
  /**
   * Name of icon used in Shortcut
   */
  icon: PropTypes.string
};
Shortcut.__docgenInfo = {
  "description": "",
  "displayName": "Shortcut",
  "props": {
    "link": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Link that the shortcut will navigate to"
    },
    "title": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Title attribute for shortcut"
    },
    "onClick": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Callback function for when shortcut is clicked"
    },
    "icon": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Name of icon used in Shortcut"
    }
  }
};