var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import TextLinkAdapter from "../../adapters/TextLinkAdapter";

var ShowMoreLess = function (_Component) {
  _inherits(ShowMoreLess, _Component);

  function ShowMoreLess(props) {
    _classCallCheck(this, ShowMoreLess);

    var _this = _possibleConstructorReturn(this, (ShowMoreLess.__proto__ || Object.getPrototypeOf(ShowMoreLess)).call(this, props));

    _initialiseProps.call(_this);

    _this.state = {
      open: false,
      showLink: true
    };
    return _this;
  }

  _createClass(ShowMoreLess, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.showMoreOrLess(this.props);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.showMoreOrLess(nextProps);
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(
        "div",
        { className: "hig__show__more__less__container" },
        React.createElement(
          "div",
          {
            className: "hig__show__more__less__content",
            style: {
              maxHeight: this.state.open ? this.childContainer.offsetHeight + "px" : this.props.maxHeight + "px",
              overflow: this.overflowAttribute(),
              marginBottom: "16px"
            }
          },
          React.createElement(
            "div",
            { ref: this.setChildContainer },
            " ",
            this.props.children
          )
        ),
        this.state.showLink && React.createElement(TextLinkAdapter, { text: this.linkLabel(), onClick: this.toggleOpen })
      );
    }
  }]);

  return ShowMoreLess;
}(Component);

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.setChildContainer = function (el) {
    _this2.childContainer = el;
  };

  this.overflowAttribute = function () {
    return _this2.state.open ? "visible" : "hidden";
  };

  this.toggleOpen = function () {
    return _this2.setState({ open: !_this2.state.open });
  };

  this.showMoreOrLess = function (props) {
    _this2.setState({
      showLink: _this2.childContainer && _this2.childContainer.offsetHeight > props.maxHeight
    });
  };

  this.linkLabel = function () {
    return _this2.state.open ? _this2.props.showLessLabel : _this2.props.showMoreLabel;
  };
};

export default ShowMoreLess;


ShowMoreLess.defaultProps = {
  maxHeight: 350,
  showMoreLabel: "Show more",
  showLessLabel: "Show less"
};

ShowMoreLess.propTypes = {
  /**
   * {Number} Max height for content container
   */
  maxHeight: PropTypes.number,
  /**
   * {String} content for label in expanded content container
   */
  showLessLabel: PropTypes.string,
  /**
   * {String} content for label in collapsed content container
   */
  showMoreLabel: PropTypes.string
};
ShowMoreLess.__docgenInfo = {
  "description": "",
  "displayName": "ShowMoreLess",
  "props": {
    "maxHeight": {
      "type": {
        "name": "number"
      },
      "required": false,
      "description": "{Number} Max height for content container",
      "defaultValue": {
        "value": "350",
        "computed": false
      }
    },
    "showLessLabel": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "{String} content for label in expanded content container",
      "defaultValue": {
        "value": "\"Show less\"",
        "computed": false
      }
    },
    "showMoreLabel": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "{String} content for label in collapsed content container",
      "defaultValue": {
        "value": "\"Show more\"",
        "computed": false
      }
    }
  }
};