var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { Tabs as VanillaTabs } from "hig-vanilla";
import TabsAdapter from "../../../adapters/Tabs/TabsAdapter";
import Tab from "./Tab";

var Tabs = function (_Component) {
  _inherits(Tabs, _Component);

  function Tabs() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Tabs);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Tabs.__proto__ || Object.getPrototypeOf(Tabs)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      activeTabIndex: _this.defaultActiveTabIndex()
    }, _this.setActiveTab = function (activeTabIndex) {
      _this.props.onTabChange(activeTabIndex);
      _this.setState({ activeTabIndex: activeTabIndex });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Tabs, [{
    key: "defaultActiveTabIndex",
    value: function defaultActiveTabIndex() {
      return this.props.activeTabIndex !== undefined ? this.props.activeTabIndex : 0;
    }
  }, {
    key: "renderActiveTabIndex",
    value: function renderActiveTabIndex() {
      return this.props.activeTabIndex !== undefined ? this.props.activeTabIndex : this.state.activeTabIndex;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var activeTabIndex = this.renderActiveTabIndex();
      var tabs = React.Children.map(this.props.children, function (tab, index) {
        var _tab$props = tab.props,
            children = _tab$props.children,
            tabProps = _objectWithoutProperties(_tab$props, ["children"]);

        return {
          active: index === activeTabIndex,
          content: children,
          tabProps: tabProps,
          index: index
        };
      });
      var activeTab = tabs.find(function (_ref2) {
        var index = _ref2.index;
        return index === activeTabIndex;
      });

      return React.createElement(
        "div",
        null,
        React.createElement(
          TabsAdapter,
          { align: this.props.align },
          tabs.map(function (_ref3) {
            var active = _ref3.active,
                tabProps = _ref3.tabProps,
                index = _ref3.index;
            return React.createElement(Tab, _extends({}, tabProps, {
              active: active,
              activateTab: _this2.setActiveTab,
              key: index,
              index: index
            }));
          })
        ),
        activeTab ? activeTab.content : null
      );
    }
  }]);

  return Tabs;
}(Component);

export default Tabs;


Tabs.propTypes = {
  /**
   * Specify how to justify the tabs within their container
   */
  align: PropTypes.oneOf(VanillaTabs.AvailableAlignments),
  /**
   * Called when user activates a tab
   */
  onTabChange: PropTypes.func,
  /**
   * Accepts Tab components
   */
  children: PropTypes.node
};

Tabs.defaultProps = {
  align: "center",
  onTabChange: function onTabChange() {}
};
Tabs.__docgenInfo = {
  "description": "",
  "displayName": "Tabs",
  "props": {
    "align": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaTabs.AvailableAlignments"
      },
      "required": false,
      "description": "Specify how to justify the tabs within their container",
      "defaultValue": {
        "value": "\"center\"",
        "computed": false
      }
    },
    "onTabChange": {
      "type": {
        "name": "func"
      },
      "required": false,
      "description": "Called when user activates a tab",
      "defaultValue": {
        "value": "() => {}",
        "computed": false
      }
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Accepts Tab components"
    }
  }
};