var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import PropTypes from "prop-types";
import React, { Component } from "react";
import { Tooltip as VanillaTooltip } from "hig-vanilla";
import TooltipAdapter from "../../adapters/TooltipAdapter";

var Tooltip = function (_Component) {
  _inherits(Tooltip, _Component);

  function Tooltip(props) {
    _classCallCheck(this, Tooltip);

    var _this = _possibleConstructorReturn(this, (Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).call(this, props));

    _this.closeTooltip = function () {
      _this.setState({ open: false });
    };

    _this.openTooltip = function () {
      _this.setState({ open: true });
    };

    _this.state = {
      open: false
    };
    return _this;
  }

  _createClass(Tooltip, [{
    key: "render",
    value: function render() {
      var target = this.props.children ? React.cloneElement(this.props.children, { onClick: this.openTooltip }) : null;
      return React.createElement(
        TooltipAdapter,
        {
          anchorPoint: this.props.anchorPoint,
          open: this.state.open,
          onClickOutside: this.closeTooltip,
          content: this.props.content
        },
        target
      );
    }
  }]);

  return Tooltip;
}(Component);

export default Tooltip;


Tooltip.propTypes = {
  /**
   * Where the tooltip will be anchored relative to target
   */
  anchorPoint: PropTypes.oneOf(VanillaTooltip.AvailableAnchorPoints),
  /**
   * Target component to open the tooltip
   */
  children: PropTypes.node,
  /**
   * Content for the tooltip
   */
  content: PropTypes.string
};
Tooltip.__docgenInfo = {
  "description": "",
  "displayName": "Tooltip",
  "props": {
    "anchorPoint": {
      "type": {
        "name": "enum",
        "computed": true,
        "value": "VanillaTooltip.AvailableAnchorPoints"
      },
      "required": false,
      "description": "Where the tooltip will be anchored relative to target"
    },
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Target component to open the tooltip"
    },
    "content": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": "Content for the tooltip"
    }
  }
};